// Isotope Grid
jQuery(window).load(function(){
	jQuery(function($){
		"use strict";
		$(".grid_holder.rtl_grid").each( function(i, e){
			
			// If found in Tabs, do not isotope
			if (! $(e).parents('.newtabs').boc_doesExist()) {
			
				var $container = $(e);
				var cols = $(e).attr('data-columns');
				var win_width = getWindowWidth();

				// Each column height settings for gutter grids - only for Metro portfolio grids && for spaced grids && for certain styles, only for Desktop and large Res. 
				if(!boc_is_mobile && (win_width >= 1281)){
					if($(e).hasClass('grid_type_metro') && ($(e).hasClass('small_spacing') || $(e).hasClass('big_spacing')) && ($(e).hasClass('p_style_type7') || $(e).hasClass('p_style_type8'))){
						var gutter = ( $(e).hasClass('small_spacing') ? 8 : 30 );
						var reg_col_h = $(e).children('.col.span_1_of_4:not(.tall_col)').first().height() - gutter;
						
						$(e).children('.col').each( function(i, e){
							$(e).attr('data-default-height',$(e).height());
							if($(e).hasClass('tall_col')){
								$(e).height(reg_col_h*2 + gutter);
							}else{
								$(e).height(reg_col_h);
							}
						});
					}
				}
				
				// Init Isotope
				$container.isotope({
				  masonry: {
					columnWidth: '.span_1_of_' + cols,
					stagger: 30,
					transitionDuration: 500,
					isRTL: true
				  },
				  isOriginLeft: false
				});

				// On Resize
				$(window).smartresize( function() {
					var win_width = getWindowWidth();
					// Rescale only if resized to smaller grid
					if(!boc_is_mobile && (win_width < 1281)){
						setTimeout(function() {
							$(e).children('.col').each( function(i, e){
								$(e).height('auto');
							});

							// ReINIT Grid
							$container.isotope({
							  masonry: {
								columnWidth: '.span_1_of_' + cols,
								stagger: 30,
								transitionDuration: 500,
								isRTL: true
							  },
							  isOriginLeft: false
							});
							
						},400);
					}
				});
				
				
				// Category Filters
				var $optionLinks = $container.prev().find(".grid_filter_inline").find("li div");

				$optionLinks.on('click',function(){
					var selector = $(this).attr("data-option-value");
					$container.isotope({ 
						filter: selector,
						stagger: 30,
						transitionDuration: 500,
						isOriginLeft: false
					});
					$container.prev().find(".grid_filter_inline li div").removeClass("current_portfolio_item");
					$(this).addClass("current_portfolio_item");
				
					return false;
				});
			}
		});				
	});
});