<?php

/**
	Counter
**/


// Register Shortcode
if( ! function_exists( 'shortcode_boc_counter' ) ) {
	function shortcode_boc_counter( $atts, $content = null ) {


		$atts = vc_map_get_attributes('boc_counter', $atts );
		extract( $atts );

		$id = rand(1,10000);

		$str = '';
		if($custom_color) {
			$css = '#counter'.$id.' .counter-digit, #counter'.$id.' .counter_post_text { color: '.esc_attr($color).';}';
			wp_enqueue_style( 'boc_shortcodes_style' );
			wp_add_inline_style( 'boc_shortcodes_style', $css );
		}
		if($centered) {
			$css_classes .= ' center';
		}	
		if($counter_size) {
			$css_classes .= ' '.$counter_size;
		}	
		if($post_text_superscript) {
			$css_classes .= ' post_text_superscript';
		}	
		
		$str .= '<div class="single_numbers_holder boc_anim_hidden '.esc_attr($css_classes).' '.($centered ? 'centered_digits' : "").' '.($white_text ? "white_text" : "").'">';
		$str  .= '<div id="counter'.$id.'" class="counter">
						<input type="hidden" class="counter_hidden" data-end-nu="'.(int)$number.'" name="counter'.$id.'-value" value="" />
						'.($post_text ? '<span class="counter_post_text">'.$post_text.'</span>': '').'
						'.($title ? '<div class="counter_desc">'.wp_kses_post($title).'</div>' : '').'
					</div>';
		$str .= '</div>';			
		return $str;
	}
	
	add_shortcode('boc_counter', 'shortcode_boc_counter');
}


// Map Shortcode in Visual Composer
vc_map( array(
	"name" => esc_html__("Animated Counter", 'boc-shortcodes-and-widgets'),
	"base" =>  "boc_counter",
	"category" => "Alea Shortcodes",
	"icon" 		=> "boc_counter",
	"weight"	=> 32,
	"params" => array(
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Title Below the Counter (optional)", 'boc-shortcodes-and-widgets'),
			"admin_label"	=> true,
			"param_name" 	=> "title",
			"std" 			=> "",
			"description"	=> esc_html__("Set your Counter Title", 'boc-shortcodes-and-widgets'),
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Number", 'boc-shortcodes-and-widgets'),
			"admin_label"	=> true,
			"param_name" 	=> "number",
			"value" 		=> "87",
			"edit_field_class" =>"vc_col-sm-4",
			"description" 	=> esc_html__("Number to count to", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Post text", 'boc-shortcodes-and-widgets'),
			"admin_label"	=> true,
			"param_name" 	=> "post_text",
			"value" 		=> "",
			"edit_field_class" =>"vc_col-sm-4",
			"description" 	=> esc_html__("Optional text to go after the number", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Post text is Superscripted", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "post_text_superscript",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"dependency"	=> Array(
				'element'	=> "post_text",
				'not_empty'	=> true,
			),
			"edit_field_class" =>"vc_col-sm-4",
		),			
		
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Size", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "counter_size",
			"value" 		=>  array(
				esc_html__("Small", "boc-shortcodes-and-widgets")				=> 'smaller_counter',
				esc_html__("Regular", "boc-shortcodes-and-widgets")			=> "regular_counter",
				esc_html__("Large", "boc-shortcodes-and-widgets")				=> "large_counter"),
			"std"			=> "regular_counter",

		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Pick Custom Color?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "custom_color",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Otherwise your Counter Digits will inherit your Main Theme Color", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "colorpicker",
			"heading"		=> "Color",
			"param_name"	=> "color",
			"value"			=> "#666666",
			"dependency"	=> Array(
				'element'	=> "custom_color",
				'not_empty'	=> true,
			)
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Dark Background?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "white_text",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Will make the Title white", 'boc-shortcodes-and-widgets'),
		),			array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Centered Counter in Column", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "centered",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),			
	)
));