<?php

/**
	Image With Icon
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_image_with_icon' ) ) {
	function shortcode_boc_image_with_icon($atts, $content = null) {

		$atts = vc_map_get_attributes('boc_image_with_icon', $atts );
		extract( $atts );
		
		$unique_id = rand(1,100000);
		
		// Pic
		$img = '';
		if($picture){
			$vc_image = wp_get_attachment_image($picture,'boc_medium');
			
			// If not passed via VC, we use default Person Icon
			if($vc_image){
				$img = $vc_image;
			}else {
				$img = '';
			}
		}else {
				$img = '';
		}
		
		// CSS Animation
		$css_animation_classes = "";
		if ( $css_animation !== '' ) {
			$css_animation_classes = 'boc_animate_when_almost_visible boc_'. $css_animation .'';
		}
		$delay_tag = ( $delay ? " data-css_delay=".(int)$delay : "");
		
		$feat_img = '<img src=""/>';
		
		// Image
		if($picture){		
			if($img_width && $img_height){
				$featured_img_url	= wp_get_attachment_url( $picture );
				$thumbnail_hard_crop = true;
				$new_feat_img_url = aq_resize( $featured_img_url, intval($img_width), intval($img_height), $thumbnail_hard_crop );
				$feat_img = '<img src="'.esc_url($new_feat_img_url).'" alt="'.esc_attr(get_post_meta(get_post_thumbnail_id(), "_wp_attachment_image_alt", true)).'">';
			}else{
				$feat_img = wp_get_attachment_image($picture,'boc_medium');
			}
		}
		
		$cursor_default_style = '';

		if($href == '') {
			$href = 'javascript:void(0)';
			$cursor_default_style = ' style="cursor: default;"'; 
		}else {
			$href = esc_url($href);
		}
		
		$str = $custom_styles = "";
		
		if($has_icon_color){
			
			$custom_styles = ' style="background-color: '.$icon_color.';"';
		}
		
		if($flat_icon){
			$css_classes .= " icon_flat";
		}else {
			$css_classes .= " icon_3d";
		}
		if($icon_size){
			$css_classes .= " ".$icon_size;
		}

		$str .=
			'
				<a href="'.$href.'" '.$cursor_default_style.' class="boc_image_with_icon_link">
				  <div id="boc_image_with_icon_'.$unique_id.'" class="boc_image_with_icon '.esc_attr($css_classes).' '.$css_animation_classes.'" '.$delay_tag.'>						
						'.$feat_img.'
	
						<div class="boc_sticky_holder">
							<div class="boc_sticky anim200">
								<div class="sticky_inner anim200">
									<div class="front circle_wrapper anim200">
										<div class="circle anim200"'.$custom_styles.'></div>
								  </div>
								</div>
							  <span class="anim200 ico '.$icon.'"></span>
							  <div class="sticky_inner anim200">
									<div class="back circle_wrapper anim200">
										<div class="circle anim200"'.$custom_styles.'></div>
									</div>
								</div>
							</div>
						</div>
				  </div>
				</a>
			';


		return $str;
	}
	
	add_shortcode('boc_image_with_icon', 'shortcode_boc_image_with_icon');
}



// Map Shortcode in Visual Composer
vc_map( array(
   "name" 	=> esc_html__("Image With Icon", 'boc-shortcodes-and-widgets'),
   "base" 	=> "boc_image_with_icon",
   "category" => "Alea Shortcodes",
   "icon" 	=> "boc_img_icon",
   "weight"	=> 58,
   "params" => array(
		array(
			"type" 			=> "attach_image",
			"heading" 		=> esc_html__("Image", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "picture",
			"description" 	=> esc_html__("Add an Image", 'boc-shortcodes-and-widgets'),
			"group"			=> "General",
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("URL Link", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "href",
			"value" 		=> "",
			"description" 	=> esc_html__("Enter a link if you want one for the image box", 'boc-shortcodes-and-widgets'),
			"group"			=> "General",
		),
		array(
			"type" 		=> "dropdown",
			"heading" 		=> esc_html__("Target", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "target",
			"value" 		=> array('_self','_blank'),
			"dependency"	=> array(
				'element'	=> "href",
				'not_empty'	=> true,
			),
			"description" 	=> esc_html__("Pick '_blank' if you want the link to open in a new tab.", 'boc-shortcodes-and-widgets'),
			"group"			=> "General",
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "blur"),
			"description"	=> esc_html__("Select one if you want this element to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
			"edit_field_class" =>"vc_col-sm-6",
			"group"			=> "General",
		),
		array(
			 "type" => "textfield",
			 "heading" => esc_html__("Override Delay (ms)", 'boc-shortcodes-and-widgets'),
			 "param_name" => "delay",
			 "value" => "",
			 "description" => esc_html__("Override the default delay for the CSS animation (e.g. 2000)", 'boc-shortcodes-and-widgets'),
			 "edit_field_class" =>"vc_col-sm-6",
			 "dependency"	=> Array(
				'element'	=> "css_animation",
				'not_empty'	=> true,
			),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
			"group"			=> "General",
		),
		array(
			"type"          => "iconpicker",
			"heading"       => "Icon",
			"param_name"    => "icon",
			"admin_label"   => true,
			"settings" => array(
				'type' => 'alea',
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display, we use (big number) to display all icons in single page
			),
			'description'   => esc_html__( 'Select icon from library.', 'boc-shortcodes-and-widgets' ),
			"group"         => esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Flat Icon", "boc-shortcodes-and-widgets"),
			"param_name"	=> "flat_icon",
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__("If not checked Icon will be 3D & will have a hover effect",	"boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),

		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("Icon Size", "boc-shortcodes-and-widgets"),
			"param_name"	=> "icon_size",
			"admin_label"	=> true,
			"value"			=> array(
				esc_html__("X-Small", "boc-shortcodes-and-widgets")			=> 'xsmall',
				esc_html__("Small", "boc-shortcodes-and-widgets")				=> 'small',
				esc_html__("Normal", "boc-shortcodes-and-widgets")			=> 'normal',
				esc_html__("Big", "boc-shortcodes-and-widgets")				=> 'big'),
			"std"			=> "normal",
			"description"	=> esc_html__("Animation will be applied to your Image box", "boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),		
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Overwrite Icon BGR Color", "boc-shortcodes-and-widgets"),
			"param_name"	=> "has_icon_color",
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__("If not checked Icon background will inherit your main theme color",	"boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),
		array(
			"type"		=> "colorpicker",
			"heading"	=> "Icon BGR Color",
			"param_name"	=> "icon_color",
			"value"		=> "#333333",
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
			"dependency"	=> Array( 'element'	=> "has_icon_color", 'not_empty' => true ),				
		),
		array(
			'type'			=> "textfield",
			"heading"		=> esc_html__( "Overwrite Image Width", 'boc-shortcodes-and-widgets'),
			'param_name'	=> "img_width",
			'std'			=> "",
			'description'	=> esc_html__( "Set both width and height to be equal if you want a nice circular Image after you make sure your image is large enough to be cropped (For example 500x500).", 'boc-shortcodes-and-widgets'),
			'group'			=> "Image Size",
		),
		array(
			'type'			=> "textfield",
			"heading"		=> esc_html__( "Overwrite Image Height", 'boc-shortcodes-and-widgets'),
			'param_name'	=> "img_height",
			'std'			=> "",
			'description'	=> esc_html__( 'Set both width and height to be equal if you want a nice circular Image after you make sure your image is large enough to be cropped (For example 500x500).', 'boc-shortcodes-and-widgets'),
			'group'			=> "Image Size",
		),
   )
));	