<?php

/**
	Post Grid
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_post_grid' ) ) {
	function shortcode_boc_post_grid($atts, $content = null) {
		
		$atts = vc_map_get_attributes('boc_post_grid', $atts );
		extract( $atts );
		
		// Img Hover Effect
		if ($img_hover_effect) {
			$img_hover_effect = ' img_hover_effect'.$img_hover_effect;
		}

		$args = array(
				'post_type' 	=> array($post_type),
			//	'category_name' => ($category_slug ? $category_slug : null), ,  # MOVED TO BOTTOM IF Statement 
				'orderby'		=> $order_by,
				'order'			=> $order,
				'showposts' 	=> $limit,
		);
		
		//  WPML compatibility
		if($category_slug) {
			$args['tax_query'] = array(
			  array(
				'taxonomy' => 'category',
				'field' => 'slug',
				'terms' => (explode( "," , str_replace(' ', '', $category_slug))),
			  )
			);
		}		
		
		// If showing all (single page)
		if($display_style=='show_all'){
			
			$args['posts_per_page'] = $limit;

		}elseif($display_style=='with_pagination'){
			
			global $paged;
			
			$args['showposts'] = $per_page;
			$args['posts_per_page'] = $per_page;
			$args['paged'] = $paged;
		}
				
		$wp_query = new WP_Query($args);
		
		$str = '';

		if ( $wp_query->have_posts()){

			$grid_id = rand(0,10000);
			$rtl_class = is_rtl() ? 'rtl_grid' : '';
			
			$str .= '<div id = "post_grid_'. $grid_id .'" data-columns="'.$columns.'" class="grid_holder '.$rtl_class.' '.($css_items_animation ? "animated_items" : "").'">';
			
			while( $wp_query->have_posts() ) : $wp_query->the_post();
				$excerpt = get_the_excerpt();
				$short_excerpt = wp_trim_words($excerpt,$excerpt_word_limit);
				$str .='<div class="col span_1_of_'.$columns.' info_item isotope_element">
							<div class="post_item_block '.($css_items_animation ? 'boc_anim_hidden boc_'.esc_attr($css_items_animation) : '').' '.(($design_preset == 'metro') ? "white_links ". esc_attr($img_hover_effect): "").' '.$design_preset.' '.(($design_preset == "boxed") ? $boxed_style : "").'">';
				
				$id = $wp_query->post->ID;

				// Show Featured Image
				if( function_exists( 'get_post_format' ) && $show_pic){

					if($img_cropping){
						
						if( ($img_cropping == 'custom') && $img_width && $img_height){

							$featured_img_url	= wp_get_attachment_url( get_post_thumbnail_id() );
							$thumbnail_hard_crop = true;
							$feat_img = aq_resize( $featured_img_url, intval($img_width), intval($img_height), $thumbnail_hard_crop );
							
						}else{
							// $img_cropping == 'cropped'
							$feat_img_arr = wp_get_attachment_image_src( get_post_thumbnail_id(), 'boc_medium');
							$feat_img = $feat_img_arr[0];
						}
					} else {
							$feat_img_arr = wp_get_attachment_image_src( get_post_thumbnail_id(), 'full');
							$feat_img = $feat_img_arr[0];				
					}
					// If image isset
					if($feat_img){					
						$str .='<div class="pic '.esc_attr($img_hover_effect).'"><a href="'. get_permalink().'"><img src="'.esc_url($feat_img).'"/><div class="img_overlay"><span class="hover_icon icon_plus"></span></div></a></div>'; 
					}
				}

				$str .= '<div class="post_item_desc">';


				// Meta
				$meta_str = '';
				if($show_meta) {
					$meta_str .= '<div class="post_block_post_meta '.($bordered_meta?"bordered":"").' clearfix">';
					$meta_str .= ($show_author) ? '<span><a href="'.get_author_posts_url(get_the_author_meta("ID")).'" class="post_block_post_author"><span class="post_author">'.get_avatar(get_the_author_meta("user_email"), "20").' '.esc_html__('by','boc-shortcodes-and-widgets').' '.get_the_author_meta("nickname").'</span></a></span>' : '';
					$meta_str .= ($show_date) ? '<span class="post_date"><span class="blog_icon boc_i-clock-outline"></span>'.boc_post_date().'</span>' : '';
					$meta_str .= ($show_like_button) ? ((ot_get_option('posts_like_functionality','on')=='on') ? get_simple_likes_button( $id ) : '') : '';
					$meta_str .= ($show_comments) ? '<span class="post_comments"><a href="'.get_comments_link( $id ).'"><span class="blog_icon blog_icon boc_i-comment-bubble"></span>'.$wp_query->post->comment_count.'</a></span>' : '';
					$meta_str .= '</div>';
				}


				// Show date according to style
				$str .= (($show_meta == 1) ? $meta_str : "");

				$str .='<h4 class="dark_links"><a href="'. get_permalink().'">'.esc_html(get_the_title()).'</a></h4>';
				$str .= (($show_meta == 2) ? $meta_str : "");
				$str .= ($show_excerpt && ($design_preset != 'metro') ? '<p>'.$short_excerpt.'</p>': '');
				$str .= (($show_meta == 3) ? $meta_str : "");
				$str .= ($show_read_more ? '<div class="more-link'.$read_more_style.' '.($bordered_read_more?"bordered":"").'"><a href="'. get_permalink().'">'.esc_html__('Read more','boc-shortcodes-and-widgets').'</a></div>' : '');

				$str .='</div>
				</div>
				</div>';
			endwhile;  // close the Loop

			wp_reset_postdata();


			$str.='
			</div>
			<div class="h10 clear"></div>';
			
			// Add pagination if needed
			if($display_style=='with_pagination'){
				$str.= boc_pagination_custom($wp_query, $pages = '', $range = 2, false);
			}
			
		}
		
		return $str;

	}
	
	add_shortcode('boc_post_grid', 'shortcode_boc_post_grid');
}


// Map Shortcode in Visual Composer
vc_map( array(
   "name" => esc_html__("Post Grid", 'boc-shortcodes-and-widgets'),
   "base" => "boc_post_grid",
   "category" => "Alea Shortcodes",
   "icon" 	=> "boc_post_grid", 
   "weight"	=> 41,
   "params" => array(
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Columns", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "columns",
			"value" 		=> Array(2,3,4,5),
			"std"			=> "3",
			"description" 	=> esc_html__("How many columns you want your items displayed in.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Grid Settings",
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("Display Style", "boc-shortcodes-and-widgets"),
			"param_name"	=> "display_style",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("Show All", "boc-shortcodes-and-widgets")			=> "show_all",
				esc_html__("With Pagination", "boc-shortcodes-and-widgets")	=> "with_pagination",
			
			),
			"description"	=> esc_html__("Pick your Grid Display Style", "boc-shortcodes-and-widgets"),
			"edit_field_class" =>"vc_col-sm-6",
			"group"			=> "Grid Settings",
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Total Items Limit", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "limit",
			"std"			=> "9",
			"description" 	=> esc_html__("How many items you want in the grid", 'boc-shortcodes-and-widgets'),
			"edit_field_class" =>"vc_col-sm-6",
			"group"			=> "Grid Settings",
			"dependency"	=> Array(
				'element'	=> "display_style",
				'value'		=> array('show_all')
			),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Items per page", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "per_page",
			"std"			=> "3",
			"description" 	=> esc_html__("How many items you want per page", 'boc-shortcodes-and-widgets'),
			"edit_field_class" =>"vc_col-sm-6",
			"group"			=> "Grid Settings",
			"dependency"	=> Array(
				'element'	=> "display_style",
				'value'		=> array('with_pagination')
			),
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_items_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_blur"),
			"description"	=> esc_html__("Animation will be applied to each single Item in your grid for a better effect", "boc-shortcodes-and-widgets"),
			"group"			=> "Grid Settings",
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Grid Settings",
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Post Type Filter", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "post_type",
			"admin_label"	=> true,
			"value" 		=> "post",
			"description" 	=> esc_html__("Filter only a certain Post Type. Could be used for Custom Post Types as well. Default is 'post'.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Category Slug Filter", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "category_slug",
			"value" 		=> "",
			"description" 	=> esc_html__("Filter only a certain Category Slug from the specified Post Type. You can list more than one (comma-separated).", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),				
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("'Order By' Clause", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "order_by",
			"value" 		=> array('none','ID','title','name','date','rand'),
			"std"			=> 'date',
			"description" 	=> __("Order results by a certain field. <a href='http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters' target='_blank'>More on the available WP options here</a>.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("'Order' Clause", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "order",
			"value" 		=> array('DESC','ASC'),
			"description" 	=> __("Order results in a Descending or Ascending order. <a href='http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters' target='_blank'>More on the order here</a>.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),

		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("Design Preset", "boc-shortcodes-and-widgets"),
			"param_name"	=> "design_preset",				
			"value"			=> array(
				esc_html__("Simple", "boc-shortcodes-and-widgets")		=> "simple",
				esc_html__("Boxed", "boc-shortcodes-and-widgets")			=> "boxed",
				esc_html__("Metro", "boc-shortcodes-and-widgets")			=> "metro",
			),
			"std"			=> "boxed",
			"edit_field_class" =>"vc_col-sm-6",
			"group"			=> "Design",
		),

		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Boxed Items style", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "boxed_style",
			"value"			=> Array(esc_html__("Simple", "boc-shortcodes-and-widgets") => '0', esc_html__("Bordered", "boc-shortcodes-and-widgets") => 'boxed_bordered', esc_html__("Shadowed", "boc-shortcodes-and-widgets") => 'boxed_shadowed'),
			"std"			=> "boxed_bordered",
			"edit_field_class" =>"vc_col-sm-6 no_top_padding",
			"dependency"	=> Array(
					'element'	=> "design_preset",
					'value'		=> array( 'boxed')
			),
			"group"			=> "Design",
		),		
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Show Post Meta Data", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_meta",
			"value" 		=> Array("Don't show" => 0, "Above Title" => 1, "Below Title" =>2, "Below Excerpt" =>3 ),
			"std"			=> "1",
			"description" 	=> esc_html__("Display Meta data like 'Date', 'Comments', 'Like Button',", 'boc-shortcodes-and-widgets'),
			"group"			=> "Design",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Author in Meta", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_author",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",			
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Date in Meta", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_date",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"edit_field_class" =>"vc_col-sm-6",			
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Comments in Meta", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_comments",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",			
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Like Button in Meta", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_like_button",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"edit_field_class" =>"vc_col-sm-6",			
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Add Top Border to Meta Data", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "bordered_meta",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),		
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Excerpt", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_excerpt",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"description" 	=> esc_html__("Set to Yes if you want an excerpt from each post to be displayed.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "design_preset",
					'value'		=> array( 'simple','boxed')
			),
			"group"			=> "Design",
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Excerpt Word limit", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "excerpt_word_limit",
			"value" 		=> "55",
			"description" 	=> __("How many words you want to further limit your excerpt to? (Default is 55. <a href='https://www.youtube.com/watch?v=Vp6pDsRCYfI' target='_blank'>How to add custom excerpts</a>)", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
				'element'	=> "show_excerpt",
				'not_empty'	=> true,
			),
			"group"			=> "Design",
		),		
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show 'Read More' link", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_read_more",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want a 'Read More' link below each item in the carousel.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "design_preset",
					'value'		=> array( 'simple','boxed')
			),			
			"group"			=> "Design",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Add Top Border to Read More link", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "bordered_read_more",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"group"			=> "Design",
			"dependency"	=> Array(
				'element'	=> "show_read_more",
				'not_empty'	=> true,
			),
		),		
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("'Read More' link style", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "read_more_style",
			"value"			=> Array(esc_html__("Simple", "boc-shortcodes-and-widgets") => '0', esc_html__("With Arrow icon", "boc-shortcodes-and-widgets") => '1'),
			"description" 	=> esc_html__("Pick a style for your 'Read More' link.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "show_read_more",
					'value'		=> "yes",
			),
			"std"			=> "1",
			"group"			=> "Design",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Show Featured Image", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_pic",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"description" 	=> esc_html__("Set to Yes if you want the Featured Images of displayed posts to be shown", 'boc-shortcodes-and-widgets'),
			"group"			=> "Images",
		),
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Hover Image Effect", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "img_hover_effect",
			"value"			=> Array("None" => '', "Zoom Out" => 1, "Zoom In" => 2, "Side" => 3, "Spin" => 4),
			"description" 	=> esc_html__("Pick a hover Image Effect", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "show_pic",
					'value'		=> "yes",
			),
			"group"			=> "Images",
		),
		
		array(
			'type'			=> "dropdown",
			"heading"		=> esc_html__( "Image Cropping", 'boc-shortcodes-and-widgets'),
			'param_name'	=> "img_cropping",
			"value"			=> Array("Original Size (No Crop)" => '', "Cropped" => 'cropped', "Custom" => 'custom'),
			'description'	=> esc_html__( "Preferable value is 'Cropped'. It uses the Theme Default Preset (600x380). For Grid effect use the 'Original Size' option.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "show_pic",
					'value'		=> "yes" ,
			),
			'group'			=> "Images",
		),			
		
		array(
			'type'			=> "textfield",
			"heading"		=> esc_html__("Overwrite Image Width", 'boc-shortcodes-and-widgets'),
			'param_name'	=> "img_width",
			'value'			=> "",
			'description'	=> esc_html__( "Enter a width in pixels if you want to overwrite the default (460). Leave empty for default.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "img_cropping",
					'value'		=> "custom" ,
			),
			'group'			=> "Images",
		),
		array(
			'type'			=> "textfield",
			"heading"		=> esc_html__( "Overwrite Image Height", 'boc-shortcodes-and-widgets'),
			'param_name'	=> "img_height",
			'value'			=> "",
			'description'	=> esc_html__('Enter a height in pixels if you want to overwrite the default (290). Leave empty for default.', 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "img_cropping",
					'value'		=> "custom" ,
			),
			'group'			=> "Images",
		),
   )
));