<?php

/**
	Animated Scroll Icon
**/


// Register Shortcode
if( ! function_exists( 'shortcode_boc_scroll_icon' ) ) {
	function shortcode_boc_scroll_icon($atts, $content = null) {
		
		$atts = vc_map_get_attributes('boc_scroll_icon', $atts );
		extract( $atts );
		
		$str = '';
		
		if ( $centered ) {
			$str .= '<div class="center">';
		}	
		if ( $dark ) {
			$css_classes .= 'dark';
		}			
		
		// CSS Animation
		$css_animation_classes = "";
		if ( $css_animation !== '' ) {
			$css_animation_classes = 'boc_animate_when_almost_visible boc_'. $css_animation .'';
		}
		$delay_tag = ( $delay ? " data-css_delay=".(int)$delay : "");
		
		$str .= '<svg id="boc_scr_icon" class="'.esc_attr($css_classes).' '.$css_animation_classes.'" '.$delay_tag.' viewBox="0 0 42 42"><path d="M21 3C14.4 3 9 8.4 9 15v10c0 6.6 5.4 13 12 13s12-6.4 12-13V15c0-6.6-5.4-12-12-12zm10 21.5C31 30.4 26.5 36 21 36s-10-5.6-10-11.5v-8.9C11 9.8 15.5 5 21 5s10 4.8 10 10.6v8.9z"></path> <circle cx="21" cy="15" r="2" class="circle"></circle></svg>';
		
		if ( $centered ) {
			$str .= '</div>';
		}
		
		return $str;
	}
	
	add_shortcode('boc_scroll_icon', 'shortcode_boc_scroll_icon');
}

// Map Shortcode in Visual Composer
vc_map( array(
	"name"			=> esc_html__( "Scroll Icon", 'boc-shortcodes-and-widgets'),
	"description"	=> esc_html__( "Animated scroller", 'boc-shortcodes-and-widgets'),
	"base"			=> "boc_scroll_icon",		
	"category" 		=> "Alea Shortcodes",
	"icon" 			=> "boc_scroll_icon",
	"weight"		=> 26,
	"params"		=> array(
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Centered?", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "centered",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Dark?", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "dark",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "blur"),
			"description"	=> esc_html__("Select one if you want this element to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
			"edit_field_class" =>"vc_col-sm-6",
		),
		array(
			"type" => "textfield",
			"heading" => esc_html__("Override Delay (ms)", 'boc-shortcodes-and-widgets'),
			"param_name" => "delay",
			"value" => "",
			"description" => esc_html__("Override the default delay for the CSS animation (e.g. 2000)", 'boc-shortcodes-and-widgets'),
			"edit_field_class" =>"vc_col-sm-6",
			"dependency"	=> Array(
				'element'	=> "css_animation",
				'not_empty'	=> true,
			),
		),		
		array(
			"type" => "textfield",
			"heading" => esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" => "css_classes",
			"value" => "",
			"description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		)
	)
));