<?php

/**
	Tabs
**/

// Register Shortcodes
if( ! function_exists( 'shortcode_boc_tabs' ) ) {
	function shortcode_boc_tabs( $atts, $content = null ) {
		
		$atts = vc_map_get_attributes('boc_tabs', $atts );
		extract( $atts );	

		$css_classes .= ' '.$tab_style;				
			
		$str = '
		<!--New Tabs-->
		<div class="newtabs clearfix '.esc_attr($type).' '.esc_attr($css_classes).'">
			<ul class="resp-tabs-list">';
		
		$str .= '
			</ul>
			<div class="resp-tabs-container">
		';
		
		$str .= do_shortcode($content);
		
		$str .= '</div>
				</div>';
			
		return $str;
	}
	
	add_shortcode('boc_tabs', 'shortcode_boc_tabs');
}

// Tab
if( ! function_exists( 'shortcode_boc_tab' ) ) {
	function shortcode_boc_tab( $atts, $content = null ) {
		
		$atts = vc_map_get_attributes('boc_tab', $atts );
		extract( $atts );

		return '<div class="single_tab_div" rel-title="'.esc_attr($atts['title']).'" rel-icon="'.esc_attr($atts['icon']).'">' . do_shortcode($content) . '</div>';
	}
	
	add_shortcode('boc_tab', 'shortcode_boc_tab');
}

// Map Shortcodes in Visual Composer
vc_map( array(
	"name" => esc_html__("Tabs", 'boc-shortcodes-and-widgets'),
	"base" => "boc_tabs",
	"as_parent" => array('only' => 'boc_tab'), // limit child shortcodes
	"content_element" => true,
	"category" => "Alea Shortcodes",
	"show_settings_on_create" => true,
	"js_view" => 'VcColumnView',
	"icon" 		=> "boc_tabs",
	"weight"	=> 37,
	"params" => array(			
		array(
			"type" => "dropdown",
			"heading" => esc_html__("Type", 'boc-shortcodes-and-widgets'),
			"param_name" => "type",
			"value" => array('horizontal','vertical'),
			"std"	=> "horizontal",
			"description" => esc_html__("Pick Tab Style", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"		=> 'dropdown',
			"heading"	=> esc_html__("Tab Style", "boc-shortcodes-and-widgets"),
			"param_name"	=> "tab_style",
			"value" => array(
				'Buttons Boxed' 	=> 'buttons_boxed_style',
				'Buttons Simple' 	=> 'button_style',
				'Minimal' 			=> 'minimal_style',
			),
			"std" => 'buttons_boxed_style'
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
	)
));

vc_map( array(
	"name" => esc_html__("Tab Item", 'boc-shortcodes-and-widgets'),
	"base" => "boc_tab",
	"icon" 		=> "boc_tabs",
	"as_child" => array('only' => 'boc_tabs'),
	"as_parent" => array('except' => array('boc_tab','boc_tabs')),
	"js_view" => 'VcColumnView',
	"params" => array(

		array(
			"type"          => "iconpicker",
			"heading"       => "Icon",
			"param_name"    => "icon",
			"admin_label"   => true,
			"settings" => array(
				'type' => 'alea',
				'emptyIcon' => true, // default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display, we use (big number) to display all icons in single page
			),
			'description'   => esc_html__( 'Select icon from library.', 'boc-shortcodes-and-widgets')
		),

		array(
			"type" => "textfield",
			"heading" => esc_html__("Title", 'boc-shortcodes-and-widgets'),
			"param_name" => "title",
			"value" => esc_html__("Tab Title", 'boc-shortcodes-and-widgets'),
			"description" => esc_html__("Set your Tab Title", 'boc-shortcodes-and-widgets'),
		),
	)
));

if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_boc_tabs extends WPBakeryShortCodesContainer {
	}
}
if ( class_exists( 'WPBakeryShortCode' ) ) {
	class WPBakeryShortCode_boc_tab extends WPBakeryShortCodesContainer {
	}
}