<?php

/**
	Top Icon Featured Text
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_top_icon_box' ) ) {
	function shortcode_boc_top_icon_box( $atts, $content = null ) {
		
		$atts = vc_map_get_attributes('boc_top_icon_box', $atts );
		extract( $atts );
		
		$link = '';
		if($href){
			$link = '<a href="'.esc_url($href).'" target="'.esc_attr($target).'">';
		}
		
		if($center == "yes"){
			$css_classes .= " center";
		}
		if($small_size == "yes"){
			$css_classes .= " small_size";
		}
		
		$unique_id = rand(1,100000);
		if($has_icon_color){
			$icon_color = esc_attr($icon_color);
			
			switch ($type){

				case 1:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type1 .icon_holder .icon_bgr { background-color: '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type1:hover .icon_holder .icon_bgr { background-color: #fff; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type1:hover .icon_holder .icon_bgr { border: 2px solid '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type1:hover .icon_holder .icon_bgr:after { border: 2px solid '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type1:hover .icon_holder i { color: '.$icon_color.';}
						#top_icon_box_'.$unique_id.'.top_icon_box.type1 .icon_holder .icon_bgr:after, #top_icon_box_'.$unique_id.'.top_icon_box.type1:hover .icon_holder .icon_bgr:after { border: 2px solid '.$icon_color.'; }
					';
					break;
				case 2:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type2 .icon_holder .icon_bgr { background-color: '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type2:hover .icon_holder .icon_bgr { background-color: #fff; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type2:hover .icon_holder i { color: '.$icon_color.';}
					';
					break;
				case 3:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type3 .icon_holder .icon_bgr:after { border: 2px solid '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type3:hover .icon_holder .icon_bgr { background-color: '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type3 .icon_holder i { color: '.$icon_color.';}
						#top_icon_box_'.$unique_id.'.top_icon_box.type3:hover .icon_holder i { color: #fff; }
					';
					break;
				case 4:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type4:hover .icon_holder  .icon_bgr { border: 2px solid '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type4:hover .icon_holder .icon_bgr:after { border: 2px solid '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type4 .icon_holder i{ color: '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type4:hover .icon_holder i { color:  '.$icon_color.'; }
					';
					break;
				case 5:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type5 .icon_holder i{ color: '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type5:hover .icon_holder i{ color:  '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type5:hover .icon_holder i{ color:  '.$icon_color.'; }
					';
					break;
				case 6:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type6:hover .icon_holder i{ color:  '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type6:after { background-color: '.$icon_color.'; }
					';
					break;
				case 7:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type7:hover .icon_holder i{ color:  '.$icon_color.'; }
						#top_icon_box_'.$unique_id.'.top_icon_box.type7:after { background-color: '.$icon_color.'; }
					';
					break;
				case 8:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type8:before { background-color: '.$icon_color.'; }
					';
					break;
				case 9:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type9 .top_icon_box_back { background-color: '.$icon_color.'; }
					';
					break;
				case 10:
					$custom_css = '
						#top_icon_box_'.$unique_id.'.top_icon_box.type10 .icon_holder i{ color: '.$icon_color.'; }
					';
					break;
			}

			wp_enqueue_style( 'boc_shortcodes_style' );
			wp_add_inline_style( 'boc_shortcodes_style', $custom_css );

		}
		
		if($type=='9'){
			$content = '<div id="top_icon_box_'.$unique_id.'" class="top_icon_box type'.esc_attr($type.' '.$css_classes).' '.($animated ? "boc_animate_when_almost_visible" : "").'"><div class="top_icon_box_face"><div class="top_icon_box_ver_center"><div class="icon_center"><i class="'.esc_attr($icon).'"></i></div><h3>'.wp_kses_post($title).'</h3></div></div>'.($href ? $link : '').'<div class="top_icon_box_back"><div class="top_icon_box_ver_center"><h3>'.wp_kses_post($title).'</h3><p>'.do_shortcode($content).'</p></div></div>'.($href ? '</a>' : '').'</div>';
		}else{
			$content = '<div id="top_icon_box_'.$unique_id.'" class="top_icon_box type'.esc_attr($type.' '.$css_classes).' '.(($animated&&($type!=5)&&($type!=10)) ? "boc_animate_when_almost_visible" : "").'">'.($href ? $link : '').'<div class="icon_holder"><div class="icon_bgr"></div><div class="icon_center"><i class="'.esc_attr($icon).'"></i></div></div>'.($href ? '</a>' : '').'<h3>'.($href ? $link : '').wp_kses_post($title).($href ? '</a>' : '').'</h3><p>'.do_shortcode($content).'</p><i class="back_icon '.esc_attr($icon).'"></i></div>';
		}
		
		return $content;
	}
	
	add_shortcode('boc_top_icon_box', 'shortcode_boc_top_icon_box');
}




// Map Shortcode in Visual Composer
vc_map( array(
   "name" => esc_html__("Top Icon Box", 'boc-shortcodes-and-widgets'),
   "description" => esc_html__("Top Icon Box", 'boc-shortcodes-and-widgets'),
   "base" 	=> "boc_top_icon_box",
   "category" => "Alea Shortcodes",
   "icon" 	=> "boc_top_icon_box",
   "weight"	=> 67,
   "params" => array(
		array(
			"type" => "textfield",
			"heading" => esc_html__("Heading", "boc-shortcodes-and-widgets"),
			"param_name" => "title",
			"admin_label"=> true,
			"value" => esc_html__("Featured Title", "boc-shortcodes-and-widgets"),
			"description" => esc_html__("Enter the Heading for your Icon Box", "boc-shortcodes-and-widgets"),
		),
		array(
			"type" 		=> "textarea_html",
			"heading" 	=> esc_html__("Text Below Title", "boc-shortcodes-and-widgets"),
			"param_name" => "content",
			"value" 	=> esc_html__("Featured Text", "boc-shortcodes-and-widgets"),
			"description"=> esc_html__("Enter the text to go below your Heading", "boc-shortcodes-and-widgets")
		),			
		array(
			"type" => "textfield",
			"heading" => esc_html__("Extra class name", "boc-shortcodes-and-widgets"),
			"param_name" => "css_classes",
			"value" => "",
			"description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "boc-shortcodes-and-widgets")
		),
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Center Content & Icon?", "boc-shortcodes-and-widgets"),
			"param_name"	=> "center",
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"description"	=> esc_html__("Check Yes if you want the box to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
		),
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Animate Box In?", "boc-shortcodes-and-widgets"),
			"param_name"	=> "animated",
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__("Check Yes if you want the box to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
		),
		array(
			"type"          => "iconpicker",
			"heading"       => "Icon",
			"param_name"    => "icon",
			"admin_label"   => true,
			"settings" => array(
				'type' => 'alea',
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display, we use (big number) to display all icons in single page
			),
			'description'   => esc_html__( 'Select icon from library.', 'boc-shortcodes-and-widgets' ),
			"group"         => esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Overwrite Icon Color", "boc-shortcodes-and-widgets"),
			"param_name"	=> "has_icon_color",
			"value"		=> array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__("If not checked Icon will inherit your main theme color",	"boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),
		array(
			"type"		=> "colorpicker",
			"heading"	=> "Icon Color",
			"param_name"	=> "icon_color",
			"value"		=> "#333333",
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
			"dependency"	=> array( 'element'	=> "has_icon_color", 'not_empty' => true ),
		),			
		array(
			"type" => "dropdown",
			"heading" => esc_html__("Style", "boc-shortcodes-and-widgets"),
			"param_name" => "type",
			"value" => array(
				"Flat Explode (1)" 		=> '1',
				"3D Explode (2)" 		=> '2',
				"Flat Fill (3)" 		=> '3',
				"Minimal Explode (4)" 	=> '4',
				"Minimal Expand (5)" 	=> '5',
				"Line BGR Expand (6)" 	=> '6',
				"Line BGR Compress (7)"	=> '7',
				"Background Unroll (8)"	=> '8',
				"Background Rotate (9)"	=> '9',
				"Text Slide Up (10)"	=> '10'
			),
			"description" => esc_html__("Pick a style for your Icon", "boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),				
		),
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Smaller icons?", "boc-shortcodes-and-widgets"),
			"param_name"	=> "small_size",
			"value"		=> array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__("If checked a smaller size icon will be used","boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
			"dependency"	=> Array(
					'element'	=> "type",
					'value'		=> Array('5', '10')
			),
		),		
		array(
			"type" => "textfield",
			"heading" => esc_html__("URL Link", "boc-shortcodes-and-widgets"),
			"param_name" => "href",
			"value" => "",
			"description" => esc_html__("Enter a link if you want one. Don't forget the http:// in front.", "boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Link', 'boc-shortcodes-and-widgets' ),	
		),
		array(
			"type" => "dropdown",
			"heading" => esc_html__("Target", "boc-shortcodes-and-widgets"),
			"param_name" => "target",
			"value" => array('_self','_blank'),
			"description" => esc_html__("Pick '_blank' if you want the link to open in a new tab.", "boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Link', 'boc-shortcodes-and-widgets'),	
		),

   )
));
