<?php

/**
	Accordion
**/

// Register Shortcodes
if( ! function_exists( 'shortcode_boc_accordion_section' ) ) {
	function shortcode_boc_accordion_section( $atts, $content = null ) {

		$atts = vc_map_get_attributes('boc_accordion_section', $atts );
		extract( $atts );
		
		if($no_sibling_toggle){
			$css_classes .= " no_sibling_toggle";
		}

		$content = '<div class="acc_holder '.esc_attr($css_classes).' '.($rounded ? "rounded" : "").' '.($right_btns ? "right_btns" : "").' '.($with_bgr ? "with_bgr" : "").' '.($border ? "border" : "").'">'.do_shortcode($content).'</div>';
		return $content;
	}
	
	add_shortcode('boc_accordion_section', 'shortcode_boc_accordion_section');
}

if( ! function_exists( 'shortcode_boc_accordion' ) ) {
	function shortcode_boc_accordion( $atts, $content = null ) {
	
		$atts = vc_map_get_attributes('boc_accordion', $atts );
		extract( $atts );		

		$content = '<div class="acc_item"><h4 class="accordion"><span class="acc_control '.($is_open ? "acc_is_open" : "").'"></span><span class="acc_heading">'.wp_kses_post($title).'</span></h4><div class="accordion_content">'.do_shortcode($content).'</div></div>';
		return $content;
	}
	add_shortcode('boc_accordion', 'shortcode_boc_accordion');
}

// Map Shortcodes in Visual Composer
vc_map( array(
	"name" 			=> esc_html__("Accordion", 'boc-shortcodes-and-widgets'),
	"base" 			=> "boc_accordion_section",
	"as_parent" 	=> array('only' => 'boc_accordion'), //limit child shortcodes
	"content_element" => true,
	"icon" 			=> "boc_accordion_section",
	"category" 		=> "Alea Shortcodes",
	"show_settings_on_create" => true,
	"js_view" 		=> 'VcColumnView',
	"weight"		=> 38,
	"params" 		=> array(
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Circular Buttons?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "rounded",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Circular buttons or squared", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Right Buttons?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "right_btns",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Buttons will be to the right", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Boxed Version?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "with_bgr",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Use Boxed Style with Background", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Border between Items?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "border",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Divide Accordion items with a grey border", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Do not toggle siblings?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "no_sibling_toggle",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set if you don't want to close siblings when clicking on an item", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
	)
) );

vc_map( array(
	"name" => esc_html__("Accordion Item", 'boc-shortcodes-and-widgets'),
	"base" => "boc_accordion",
	"icon" 	=> "boc_accordion_section",
	"as_child" => array('only' => 'boc_accordion_section'), // Use only|except attributes to limit parent (separate multiple values with comma)
	"content_element" => true,
	"params" => array(
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Title", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "title",
			"admin_label"	=> true,
			"value" 		=> esc_html__("Accordion Title Text", 'boc-shortcodes-and-widgets'),
			"description" 	=> esc_html__("Set your Accordion Title", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "textarea_html",
			"heading" 		=> esc_html__("Accordion Text", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "content",
			"value" 		=> esc_html__("Accordion Content Text", 'boc-shortcodes-and-widgets'),
			"description" 	=> esc_html__("Enter the text for your accordion item.", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Open By Default", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "is_open",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set if you want this Item to be Open by default at Page load. Only one item per accordion should be open.", 'boc-shortcodes-and-widgets'),
		),	
	)
));

if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_boc_accordion_section extends WPBakeryShortCodesContainer {
	}
}
if ( class_exists( 'WPBakeryShortCode' ) ) {
	class WPBakeryShortCode_boc_accordion extends WPBakeryShortCode {
	}
}