<?php

/**
	Circle Counter
**/


// Register Shortcode
if( ! function_exists( 'shortcode_boc_circle_counter' ) ) {
	function shortcode_boc_circle_counter( $atts, $content = null ) {
	
		$atts = vc_map_get_attributes('boc_circle_counter', $atts );
		extract( $atts );

		$id = rand(0,10000);

		if(!$custom_color) {
			$color = boc_get_main_color();
		}
		if($centered) {
			$css_classes .= ' center';
		}
		if($angle) {
			$css_classes .= ' half_circle';
		}
		
		$icon_str = ($icon 	? " <i class='icon ".$icon."'></i> " : '');
		
		if($size == 120) {
			$css_classes .= ' small_counter';
		} elseif($size == 160) {
			$css_classes .= ' large_counter';
		}

		$str = '<div class="circ_numbers_holder '.esc_attr($css_classes).' '.($white_text ? "white_text" : "").'">
					<div class="circ_counter" data-color="'.esc_attr($color).'" data-angle="'.esc_attr($angle).'" data-size="'.esc_attr($size).'" data-white_text="'.($white_text ? "1" : "0").'">
						<canvas width='.esc_attr($size).' height='.esc_attr($size).'  data-end-nu="'.(int)$number.'"></canvas>
						<div class="circ_counter_text_holder '.($icon_str ? 'iconed' : '').'">'.
							($icon_str ? $icon_str : '').
							'<span class="circ_counter_text" id="circ_counter_text'.$id.'"></span><span class="counter_percent_sign heading_font">%</span>
						</div>
						<div class="circ_counter_desc">'.wp_kses_post($title).'</div>
					</div>
				</div>';

		return $str;
	}
	
	add_shortcode('boc_circle_counter', 'shortcode_boc_circle_counter');
}

// Map Shortcode in Visual Composer
vc_map( array(
	"name" => esc_html__("Circle Counter", 'boc-shortcodes-and-widgets'),
	"base" =>  "boc_circle_counter",
	"category" => "Alea Shortcodes",
	"icon" 		=> "boc_circle_counter",
	"weight"	=> 34,
	"params" => array(
		array(
			"type" 			=> "textfield",
			"admin_label"	=> true,
			"heading" 		=> esc_html__("Title", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "title",
			"value" 		=> esc_html__("Title", 'boc-shortcodes-and-widgets'),
			"description" 	=> esc_html__("Set your Counter Title", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" => "textfield",
			"admin_label"	=> true,
			"heading" => esc_html__("Number", 'boc-shortcodes-and-widgets'),
			"param_name" => "number",
			"value" => "87",
			"description" => esc_html__("Number to count to (as percentage)", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "dropdown",
			"heading"		=> esc_html__( "Size", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "size",
			"value"			=> array(
				"Small"		=> "120",
				"Medium"	=> "140",
				"Large"		=> "160",
			),
			"std"			=> "140",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Pick Custom Color?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "custom_color",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Otherwise your Bar Graph will inherit your Main Theme Color", 'boc-shortcodes-and-widgets'),
		),			
		array(
			"type"			=> "colorpicker",
			"heading"		=> "Color",
			"param_name"	=> "color",
			"value"			=> "#666666",
			"dependency"	=> Array(
				'element'	=> "custom_color",
				'not_empty'	=> true,
			)
		),
		array(
			"type"          => "iconpicker",
			"heading"       => "Icon (optional)",
			"param_name"    => "icon",
			"settings" => array(
				'type' 		=> 'alea',
				'iconsPerPage' => 4000,
			),
			'description' 	=> esc_html__( 'Select icon from library to show instead of the Number', 'boc-shortcodes-and-widgets' ),
		),		
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Half Circle Only?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "angle",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Will animate only half circle Gauge", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Centered Counter in Column", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "centered",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Dark Background?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "white_text",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Will make the Title white and the circle BGR dark", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
	)
));