<?php
/**
	Content Slider
**/

// Register Shortcodes

// Content Slider
if( ! function_exists( 'shortcode_boc_content_slider' ) ) {
	function shortcode_boc_content_slider($atts, $content = null) {

		$atts = vc_map_get_attributes('boc_content_slider', $atts );
		extract( $atts );

		if(!$content) return;
		
		// Animation Type
		if ($animation == 'Slide') {
			$anim_type_code = 'animateOut: false,	animateIn: false';
		} elseif ($animation == 'Fade') {
			$anim_type_code = 'animateOut:"fadeOut",	animateIn: "fadeIn"';
		} elseif ($animation == 'Bottom-Top') {
			$anim_type_code = 'animateOut:"fadeOutDown",	animateIn: "fadeInUp"';
		} elseif ($animation == 'Flip') {
			$anim_type_code = 'animateOut:"fadeOutDown",	animateIn: "flipInX"';
		}

		// Arrows
		$nav = (($navigation == "Arrows") || ($navigation == "Both"));

		// Dots
		$dots = (($navigation == "Dots") || ($navigation == "Both"));
		if($dots){
			$css_classes .= ' has_dots';
			$css_classes .= ' dots_pos_'.$dots_position;
		}
		if ( $white_text !== '' ) {
			$css_classes .= ' white_text';
		}

		// generate rand ID
		$slider_id = rand(1,10000);

		$str = '<div class="content_slides '.($nav ? "content_slides_arrowed arrows_pos_".$arrows_position : "").' '.$css_classes.'" id="content_slides_'.$slider_id.'">';
		$str .= do_shortcode($content);
		$str .= '</div>';
		
			
		$js = '
			/* Content Slider :: START */
			jQuery(document).ready(function($) {
				
				var slider_el = $("#content_slides_'.$slider_id.'");
				
				var args = {
						items: 				1,
			'.(($animation != "Slide") ? " mouseDrag:			false," : "").'	
						autoplay:			'.($autoplay ? "true" : "false").',
						autoplayTimeout:		'.(int)$autoplay_interval.',
						nav: 				'.($nav 	? "true" : "false").',
			'.( $nav ? "	navText:			[\"<span class='icon boc_i-angle-". (is_rtl() ? 'right' : 'left') ."-circle'></span>\",\"<span class='icon boc_i-angle-". (is_rtl() ? 'left' : 'right') ."-circle'></span>\"]," : "").'
						autoHeight: 			'.($auto_height	? "true" : "false").',
						smartSpeed:			'.(int)$speed.',
						dots:				'.($dots	? "true" : "false").',
						loop: 				'.($loop	? "true" : "false").',
						slideBy: 			1,
						rtl: 			' . (is_rtl() ? 'true' : 'false') . ',
						navRewind: 			false,
						responsive:{
							0:{
								animateOut: false,	animateIn: false,
							},
							769:{
								'.$anim_type_code.',
							}
						},
						'.$anim_type_code.',
						onInitialized:  showSlider_'.$slider_id.'
				};

				// Delay it a bit to let the smartresize one kick in
				setTimeout(function() {
					slider_el.owlCarousel(args);
				}, 500);

				/* Refresh it for full width rows */
				$(window).smartresize( function() {
					$("#content_slides_'.$slider_id.'").fadeTo(0,0);
					$("#content_slides_'.$slider_id.'").trigger("destroy.owl.carousel").removeClass("owl-carousel owl-loaded");
					$("#content_slides_'.$slider_id.'").find(".owl-stage-outer").children().unwrap();
					$("#content_slides_'.$slider_id.'").owlCarousel(args);
				});
				
				/* Show after initialized */
				function showSlider_'.$slider_id.'() {
					$("#content_slides_'.$slider_id.'").fadeTo(0,1);
					$("#content_slides_'.$slider_id.' .owl-item .boc_owl_lazy").css("opacity","1");
				}						
			});
			/* Content Slider :: END */';

		wp_enqueue_script( 'boc_shortcodes_script');
		wp_add_inline_script( 'boc_shortcodes_script', $js );


		$css = '#content_slides_'.$slider_id.'.owl-carousel .animated {-webkit-animation-duration: '.(int)$speed.'ms; animation-duration: '.(int)$speed.'ms;}';
		wp_enqueue_style( 'boc_shortcodes_style' );
		wp_add_inline_style( 'boc_shortcodes_style', $css );

		return $str;		
	}
	
	add_shortcode('boc_content_slider', 'shortcode_boc_content_slider');
}	

// Content Slide Item
if( ! function_exists( 'shortcode_boc_content_slider_item' ) ) {
	function shortcode_boc_content_slider_item($atts, $content = null) {

		$atts = vc_map_get_attributes('boc_content_slider_item', $atts );
		extract( $atts );

		$str = '<div class="content_slide_item '.esc_attr($css_classes).' boc_owl_lazy">';
		$str .= do_shortcode($content);
		$str .= '</div>';

		return $str;
	}
	
	add_shortcode('boc_content_slider_item', 'shortcode_boc_content_slider_item');
}	
	
// Map Shortcodes in Visual Composer
vc_map( array(
	"name" 		=> esc_html__("Content Slider", 'boc-shortcodes-and-widgets'),
	"base" 		=> "boc_content_slider",
	"as_parent" => array('only' => 'boc_content_slider_item'), //limit child shortcodes
	"content_element" => true,
	"icon" 		=> "boc_content_slider",
	"category" 	=> "Alea Shortcodes",
	"show_settings_on_create" => true,
	"js_view" 	=> 'VcColumnView',
	"weight"  	=> 27,
	"params" => array(
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Animation Type", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "animation",
			"value" 		=> array('Slide','Fade','Bottom-Top'),
			"std"			=> "Slide",
			"description" 	=> esc_html__("Set your Animation type", 'boc-shortcodes-and-widgets'),
		),		
			array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Slider Navigation", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "navigation",
			"value"			=> Array("Arrows", "Dots", "Both"),
			"description" 	=> esc_html__("Select a Navigation Type", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "dropdown",
			"heading"		=> esc_html__("Left/Right Arrow Position", 'boc-shortcodes-and-widgets'),
			"param_name"		=> "arrows_position",
			"description"		=> esc_html__('Inside may look better in full width Rows', 'boc-shortcodes-and-widgets'),
			"value" 		=> array('Outside','Inside'),
			"dependency"		=> Array(
				'element'	=> "navigation",
				'value'		=> array( 'Arrows', 'Both' )
			),
		),
		array(
			"type"			=> "dropdown",
			"heading"		=> esc_html__("Dots Navigation Position", 'boc-shortcodes-and-widgets'),
			"param_name"		=> "dots_position",
			"description"		=> esc_html__('Inside may look better in full width Rows', 'boc-shortcodes-and-widgets'),
			"value" 		=> array('Below','Left-inside', 'Right-inside'),
			"dependency"		=> Array(
				'element'	=> "navigation",
				'value'		=> array( 'Dots', 'Both' )
			),
		),		
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__('White Text Color', 'boc-shortcodes-and-widgets'),
			"param_name" 	=> 'white_text',
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__('Check when using dark backgrounds to force White text, Navigation Dots & Arrows', 'boc-shortcodes-and-widgets'),
		),			
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("AutoPlay the slider?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "autoplay",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Testimonial Slider to autoplay", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("AutoPlay Interval", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "autoplay_interval",
			"value" 		=> array('4000','6000','8000','10000','12000','14000'),
			"std"			=> "6000",
			"description" 	=> esc_html__("Set the Autoplay Interval (miliseconds).", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "autoplay",
					'not_empty'	=> true,
			),
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Animation Speed", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "speed",
			"value" 		=> array('250','500','750','1000'),
			"std"			=> "250",
			"description" 	=> esc_html__("Set the length of the Slider Animation (miliseconds)", 'boc-shortcodes-and-widgets'),
		),			
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Loop the slider", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "loop",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Slider to be Infinite", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Enable AutoHeight", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "auto_height",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes for an AutoHeight slider - it will resize according to the item heights in sight", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
	)
));

vc_map( array(
	"name" => esc_html__("Content Slider Item", 'boc-shortcodes-and-widgets'),
	"base" => "boc_content_slider_item",
	"icon" 		=> "boc_content_slider",
	"as_child" => array('only' => 'boc_content_slider'),
	"as_parent" => array('except' => 'boc_custom_slider,boc_custom_slider_item,boc_content_slider,boc_content_slider_item,boc_img_carousel,boc_img_slider,boc_img_gallery,boc_portfolio_carousel,boc_portfolio_grid,boc_posts_carousel,boc_post_grid,boc_logo_gallery,boc_tabs,boc_tab,boc_testimonials,boc_testimonial,boc_accordion,vc_tta_section,vc_section'),
	"content_element" => true,
	"js_view" => 'VcColumnView',
	"params" => array(
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),		
	)
));

if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_boc_content_slider extends WPBakeryShortCodesContainer {
	}
}
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_boc_content_slider_item extends WPBakeryShortCodesContainer {
	}
}
