<?php

/**
	Person
**/


// Register Shortcode
if( ! function_exists( 'shortcode_boc_person' ) ) {
	function shortcode_boc_person($atts, $content = null) {

		$atts = vc_map_get_attributes('boc_person', $atts );
		extract( $atts );
			
		// Pic
		$img = '';
		if($picture){
			$vc_image = wp_get_attachment_image($picture,'full');
			
			// If not passed via VC, we use default Person Icon
			if($vc_image){
				$img = $vc_image;
			}else {
				$img = get_template_directory_uri().'/images/user.png';
			}
		}else {
				$img = '<img src="'.get_template_directory_uri().'/images/user.png" />';
		}				
		
		if($centered) {
			$css_classes .= ' center';
		}
		if($bordered) {
			$css_classes .= ' bordered';
		}

		// CSS Animation
		$css_animation_classes = "";
		if ( $css_animation !== '' ) {
			$css_animation_classes = 'boc_animate_when_almost_visible boc_'. $css_animation .'';
		}
		$delay_tag = ( $delay ? " data-css_delay=".(int)$delay : "");
					
		$str='	<div class="team_block_content '.esc_attr($css_classes).' '.esc_attr($css_animation_classes).'" '.$delay_tag.'>
					<div class="pic">
						'.($href ? '<a href="'.esc_url($href).'" target="'.esc_attr($target).'">' : '').'
						<div class="team_image '.(!$circled ? 'boxed' : 'circle').' '.($flat_img ? 'flat_img' : '').'">'.$img.'</div>
						'.($href?'</a>':'').'
						
						
						<div class="team_block">
							<h4>'.($href?'<a href="'.esc_url($href).'">':'').wp_kses_post($name).($href?'</a>':'').'</h4>
							<p class="team_desc">'.wp_kses_post($title).'</p>
							<p class="team_text">'.do_shortcode($content).'</p>
							<div class="team_icons">
						'.($twitter ? '<a target="_blank" href="'.esc_url($twitter).'" title="Twitter"><span class="icon fa fa-twitter"></span></a>': '').'
						'.($facebook ? '<a target="_blank" href="'.esc_url($facebook).'" title="Facebook"><span class="icon fa fa-facebook-f"></span></a>': '').'
						'.($googleplus ? '<a target="_blank" href="'.esc_url($googleplus).'" title="Google+"><span class="icon fa fa-google"></span></a>': '').'
						'.($linkedin ? '<a target="_blank" href="'.esc_url($linkedin).'" title="LinkedIn"><span class="icon fa fa-linkedin"></span></a>': '').'
						'.($pinterest ? '<a target="_blank" href="'.esc_url($pinterest).'" title="Pinterest"><span class="icon fa fa-pinterest"></span></a>': '').'
						'.($instagram ? '<a target="_blank" href="'.esc_url($instagram).'" title="Instagram"><span class="icon fa fa-instagram"></span></a>': '').'
						'.($xing ? '<a target="_blank" href="'.esc_url($xing).'" title="Xing"><span class="icon fa fa-xing"></span></a>': '').'
						'.($email ? '<a target="_blank" href="mailto:'.antispambot(wp_kses_post($email)).'" title="Email"><span class="icon fa fa-envelope"></span></a>': '').'
							</div>
						</div>
					</div>
				</div>
			';

		return $str;
	}

	add_shortcode('boc_person', 'shortcode_boc_person');	
}




// Map Shortcode in Visual Composer
vc_map( array(
	"name"			=> esc_html__( "Person", 'boc-shortcodes-and-widgets'),
	"description"	=> esc_html__( "Add a staff person summary", 'boc-shortcodes-and-widgets'),
	"base"			=> "boc_person",		
	"icon" 			=> "boc_person",	
	"category" 		=> "Alea Shortcodes",
	"weight"		=> 28,
	"params"		=> array(
		array(
			"type" 			=> "attach_image",
			"heading" 		=> esc_html__("Picture", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "picture",
			"description" 	=> esc_html__("Add a Person Image", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Circled Image?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "circled",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Flat Image?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "flat_img",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("No white border and shadow on Person Image?", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Center Text?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "centered",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Bordered Text?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "bordered",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("URL Link", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "href",
			"value" 		=> "",
			"description" 	=> esc_html__("Enter a link if you want one for the picture and name", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 		=> "dropdown",
			"heading" 		=> esc_html__("Target", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "target",
			"value" 		=> array('_self','_blank'),
			"dependency"	=> array(
				'element'	=> "href",
				'not_empty'	=> true,
			), 
			"description" 	=> esc_html__("Pick '_blank' if you want the link to open in a new tab.", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "textfield",
			"heading"		=> esc_html__("Name", 'boc-shortcodes-and-widgets'),
			"admin_label"	=> true,
			"param_name"	=> "name",
			"value"			=> "Name",
		),
		array(
			"type"			=> "textfield",
			"heading"		=> esc_html__("Title", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "title",
			"value"			=> "Title",
		),
		array(
			"type"			=> "textarea_html",
			"heading"		=> esc_html__("Description", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "content",
			"value"			=> "Description",
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "blur"),
			"description"	=> esc_html__("Select one if you want this element to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
			"edit_field_class" =>"vc_col-sm-6",
		),
		array(
			 "type" => "textfield",
			 "heading" => esc_html__("Override Delay (ms)", 'boc-shortcodes-and-widgets'),
			 "param_name" => "delay",
			 "value" => "",
			 "description" => esc_html__("Override the default delay for the CSS animation (e.g. 2000)", 'boc-shortcodes-and-widgets'),
			 "edit_field_class" =>"vc_col-sm-6",
			 "dependency"	=> Array(
				'element'	=> "css_animation",
				'not_empty'	=> true,
			),
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "textfield",
			"heading"		=> "Twitter",
			"param_name"	=> "twitter",
			"group"			=> "Links",
		),	
		array(
			"type"			=> "textfield",
			"heading"		=> "Facebook",
			"param_name"	=> "facebook",
			"group"			=> "Links",
		),	
		array(
			"type"			=> "textfield",
			"heading"		=> "Google Plus",
			"param_name"	=> "googleplus",
			"group"			=> "Links",
		),	
		array(
			"type"			=> "textfield",
			"heading"		=> "LinkedIn",
			"param_name"	=> "linkedin",
			"group"			=> "Links",
		),	
		array(
			"type"			=> "textfield",
			"heading"		=> "Pinterest",
			"param_name"	=> "pinterest",
			"group"			=> "Links",
		),
		array(
			"type"			=> "textfield",
			"heading"		=> "Instagram",
			"param_name"	=> "instagram",
			"group"			=> "Links",
		),
		array(
			"type"			=> "textfield",
			"heading"		=> "Xing",
			"param_name"	=> "xing",
			"group"			=> "Links",
		),	
		array(
			"type"			=> "textfield",
			"heading"		=> "Email",
			"param_name"	=> "email",
			"group"			=> "Links",
		),	
		
	)
));