<?php

/**
	Portfolio Carousel
**/

if ( ! function_exists('is_plugin_active')){ 
	include_once( ABSPATH . 'wp-admin/includes/plugin.php' ); // load is_plugin_active() function if no available
}

// Only if Portfolio plugin is enabled
if(function_exists('boc_portfolio_register')){

	// Register Shortcode
	if( ! function_exists( 'shortcode_boc_portfolio_carousel' ) ) {
		function shortcode_boc_portfolio_carousel($atts, $content = null) {
			
			$atts = vc_map_get_attributes('boc_portfolio_carousel', $atts );
			extract( $atts );
		
			// Arrows
			$nav = (($navigation == "Arrows") || ($navigation == "Both"));
			if ($nav && ($arrows_position!='top')){
				$css_classes .= ' owl_side_arrows';
			}
			// Centered
			if($centered) {
				$css_classes .= ' center';
			}
			
			if($hide_hover_icon) {
				$css_classes .= ' hide_hover_icon';
			}			
			
			// Dots
			$dots = (($navigation == "Dots") || ($navigation == "Both"));
			if($dots){
				$css_classes .= ' has_dots'; 
			}	

			// Img Hover Effect
			if ($img_hover_effect){
				$img_hover_effect = ' img_hover_effect'.$img_hover_effect;
			}

			// CSS Animation
			$css_animation_classes = "";
			if ( $css_items_animation != '' ) {
				$css_animation_classes = 'boc_animate_when_almost_visible boc_'. $css_items_animation .'';
			}	
			
			// Display Type
			$portfolio_style = 'type'.$display_style;

			$projects = boc_get_portfolio_items($limit, $order_by, $order, $category_name);

			$str = '';

			if($projects->have_posts()){

				$carousel_id = rand(0,10000);

				$str.='
				<div class="info_block">
					<div class="portfolio_carousel_holder '.esc_attr($css_classes).' '.($display_style==6 ? "padded_carousel" : "").'">
						<div id="portfolio_carousel_'.$carousel_id.'" style="opacity:0;">';
							while($projects->have_posts()): $projects->the_post(); 
							if(has_post_thumbnail()): 
							
								$taxonomy = 'portfolio_category';
								$terms = get_the_terms( $projects->post->ID , $taxonomy );
								$cats = array();
								
								if (! empty( $terms ) ) :
									foreach ( $terms as $term ) {
										
										$link = get_term_link( $term, $taxonomy );
										if ( !is_wp_error( $link ) )
											$cats[] = $term->name;
									}
								endif;
								
								// Feat. Image								
								if($img_width && $img_height){
									$featured_img_url	= wp_get_attachment_url( get_post_thumbnail_id($projects->post->ID) );
									$thumbnail_hard_crop = true;
									$new_feat_img_url = aq_resize( $featured_img_url, intval($img_width), intval($img_height), $thumbnail_hard_crop );
									$feat_img = '<img src="'.esc_url($new_feat_img_url).'" alt="'.esc_attr(get_post_meta(get_post_thumbnail_id(), "_wp_attachment_image_alt", true)).'">';
								}else{
									$feat_img = get_the_post_thumbnail($projects->post->ID, 'boc_medium');
								}

								$str.=
								'	<div class="info_item '.esc_attr($css_animation_classes).' '.(!$css_animation_classes ? "boc_owl_lazy" : "").'">
										<a href="'.get_permalink().'" class="pic_info_link_'.esc_attr($portfolio_style).'">
											<div class="pic_info '.esc_attr($portfolio_style).'">
												<div class="pic '.esc_attr($img_hover_effect).'"><div class="plus_overlay"></div><div class="plus_overlay_icon"></div>'.$feat_img.'<div class="img_overlay_icon"><span class="portfolio_icon icon_link"></span></div></div>
												<div class="info_overlay">
													<div class="info_overlay_padding">
														<div class="info_desc">
															<span class="portfolio_icon icon_link"></span>
															<h3>'.get_the_title().'</h3>
															<section>'.implode(' / ', $cats).'</section>
														</div>
													</div>
												</div>
											</div>
										</a>
									</div>
								';

							endif; endwhile;
							
							wp_reset_postdata();
							
							$str.='
						</div>
					</div>
				</div>

				<div class="h10 clear"></div>';
							
				$js = '
					/* Portfolio Carousel :: START */
					jQuery(document).ready(function($) {			

						// Load carousel after its images are loaded
						boc_preloadImages($("#portfolio_carousel_'.$carousel_id.' img"), function () {
						
							var carousel = $("#portfolio_carousel_'.$carousel_id.'");
							
							var args = {
									items: 				'.(int)$items_visible.',
									autoplay:			'.(esc_js($autoplay) ? "true" : "false").',
									autoplayTimeout:	'.(int)$autoplay_interval.',
									loop: 				'.($loop	? "true" : "false").',
									nav: 				'.(esc_js($nav) 	? "true" : "false").',
									dots: 				'.(esc_js($dots) 	? "true" : "false").',
									autoHeight: 		false,
									smartSpeed:			'.(int)$speed.',
									navText:			'.((esc_js($nav) && ($arrows_position!='top')) ? 
									"[\"<span class='icon boc_i-angle-". (is_rtl() ? 'right' : 'left') ."-circle'></span>\",\"<span class='icon boc_i-angle-". (is_rtl() ? 'left' : 'right') ."-circle'></span>\"]" : 
									"[\"<span class='icon fa fa-angle-". (is_rtl() ? 'right' : 'left') ."'></span>\",\"<span class='icon fa fa-angle-". (is_rtl() ? 'left' : 'right') ."'></span>\"]").',
									slideBy: 			'.(int)$items_slided.',

									navRewind: false,
									rtl: 				' . (is_rtl() ? 'true' : 'false') . ',
									margin:30,
									responsive:{
										0:{
										  items:1,
										},
										480:{
										  items:1,
										  margin:20,
										},
										769:{
										  items:'.(int)$items_visible.'
										}
									},
									onInitialized:  showCarousel_'.$carousel_id.'
							}
							
							carousel.owlCarousel(args);

							var initital_width = carousel.css("width");		
							
							/* Refresh it for full width rows */
							$(window).load(function(){
								if(carousel.css("width") != initital_width) {
									carousel.trigger("destroy.owl.carousel").removeClass("owl-carousel owl-loaded");
									carousel.find(".owl-stage-outer").children().unwrap();
									carousel.owlCarousel(args);
								}
							});
						});
						
						
						/* Show after initialized */
						function showCarousel_'.$carousel_id.'() {
							$("#portfolio_carousel_'.$carousel_id.'").fadeTo(0,1);
							$("#portfolio_carousel_'.$carousel_id.' .owl-item .boc_owl_lazy").css("opacity","1");
						}

					});
					/* Portfolio Carousel :: END */';
					
				wp_enqueue_script( 'boc_shortcodes_script');
				wp_add_inline_script( 'boc_shortcodes_script', $js );
			}

			return $str;
		}

		add_shortcode('boc_portfolio_carousel', 'shortcode_boc_portfolio_carousel');
	}


	// Map Shortcode in Visual Composer
	vc_map( array(
		"name" 		=> esc_html__("Portfolio Carousel", 'boc-shortcodes-and-widgets'),
		"base" 		=> "boc_portfolio_carousel",
		"category" 	=> "Alea Shortcodes",
		"icon" 		=> "boc_portfolio_carousel",
		"weight"	=> 42,
		"params" => array(
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Total Visible Items", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "items_visible",
				"value" 		=> Array(1,2,3,4,5,6),
				"std"			=> "3",
				"description" 	=> esc_html__("How many items you want the viewport to be consisted of.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Slider Settings",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Slide Items at once", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "items_slided",
				"value" 		=> Array(1,2,3,4,5,6),
				"std"			=> "1",
				"description" 	=> esc_html__("How many items will slide per click.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Slider Settings",
			),			
			array(
				"type"			=> 'dropdown',
				"heading" 		=> esc_html__("Slider Navigation", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "navigation",
				"value"			=> Array("Arrows", "Dots", "Both"),
				"description" 	=> esc_html__("Select a Navigation Type", 'boc-shortcodes-and-widgets'),
				"group"			=> "Slider Settings",
			),
			array(
				"type"			=> 'dropdown',
				"heading" 		=> esc_html__("Arrows Position", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "arrows_position",
				"value"			=> Array("Top"=>"top", "Side"=>"side"),
				"description" 	=> esc_html__("Select Position of Carousel Arrows. Top arrows are absolutely positioned above the carousel!", 'boc-shortcodes-and-widgets'),
				"dependency"	=> Array(
						'element'	=> "navigation",
						'value'		=> Array("Arrows", "Both"),
				),
				"group"			=> "Slider Settings",
			),			
			array(
				"type"			=> 'checkbox',
				"heading" 		=> esc_html__("AutoPlay the slider?", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "autoplay",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"description" 	=> esc_html__("Set to Yes if you want your Testimonial Slider to autoplay", 'boc-shortcodes-and-widgets'),
				"group"			=> "Slider Settings",						
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("AutoPlay Interval", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "autoplay_interval",
				"value" 		=> array('4000','6000','8000','10000','12000','14000'),
				"std"			=> "6000",
				"description" 	=> esc_html__("Set the Autoplay Interval (miliseconds).", 'boc-shortcodes-and-widgets'),
				"dependency"	=> Array(
						'element'	=> "autoplay",
						'not_empty'	=> true,
				),
				"group"			=> "Slider Settings",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Animation Speed", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "speed",
				"value" 		=> array('250','500','750','1000'),
				"std"			=> "250",
				"description" 	=> esc_html__("Set the length of the Slider Animation (miliseconds)", 'boc-shortcodes-and-widgets'),
				"group"			=> "Slider Settings",
			),
			array(
				"type"			=> 'checkbox',
				"heading" 		=> esc_html__("Loop the slider", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "loop",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"description" 	=> esc_html__("Set to Yes if you want your Slider to be Infinite", 'boc-shortcodes-and-widgets'),
				"group"			=> "Slider Settings",
			),
			array(
				"type"		=> "dropdown",
				"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
				"param_name"	=> "css_items_animation",
				"admin_label"	=> true,				
				"value"			=> array(
					esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
					esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
					esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
					esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
					esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
					esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
					esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom",
					esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom_out",
					esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_blur"),
				"description"	=> esc_html__("Animation will be applied to each single Item in your grid for a better effect", "boc-shortcodes-and-widgets"),
				"group"			=> "Slider Settings",
			),
			array(
				"type" 			=> "textfield",
				"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "css_classes",
				"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Slider Settings",
			),
			array(
				"type" 			=> "textfield",
				"heading" 		=> esc_html__("Category Name Filter (slug)", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "category_name",
				"value" 		=> "",
				"description" 	=> esc_html__("Filter only a certain Category from your portfolio items (comma-separated)", 'boc-shortcodes-and-widgets'),
				"group"			=> "Query",
			),				
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("'Order By' Clause", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "order_by",
				"value" 		=> array('none','ID','title','name','date','rand'),
				"std"			=> 'date',
				"description" 	=> __("Order results by a certain field. <a href='http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters' target='_blank'>More on the available WP options here</a>.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Query",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("'Order' Clause", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "order",
				"value" 		=> array('DESC','ASC'),
				"description" 	=> __("Order results in a Descending or Ascending order. <a href='http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters' target='_blank'>More on the order here</a>.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Query",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Display Style", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "display_style",
				"value" 		=> array(
					"Diagonal Unroll (1)"		=> '1',
					"Overlay Fade (2)"	 		=> '2',
					"Overlay Fade Up (3)" 		=> '3',
					"Circular Explode (4)" 		=> '4',
					"Text Overlay (5)"		 	=> '5',
					"Rotate (6)"			 	=> '6',
					"Padded Text Overlay (7)"	=> '7',
					"Dark Overlay Text (8)"		=> '8'
				),
				"description" 	=> esc_html__("Pick a Display Style. Explore them all to see what best fits your needs.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Design",
			),
			array(
				"type"			=> 'checkbox',
				"heading"		=> esc_html__("Center Texts?", "boc-shortcodes-and-widgets"),
				"param_name"	=> "centered",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"std"			=> "yes",
				"description"	=> esc_html__("Check if you want the box texts centered.", "boc-shortcodes-and-widgets"),
				"group"			=> "Design",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Max Number of Items in Carousel", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "limit",
				"value" 		=> Array(1,2,3,4,5,6,7,8,9,10,12,16,20,40),
				"std"			=> "10",
				"description" 	=> esc_html__("How many items you want to limit your carousel to. Default is  10.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Design",
			),
			array(
				"type"			=> 'checkbox',
				"heading" 		=> esc_html__("Hide Hover Icon?", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "hide_hover_icon",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"description" 	=> esc_html__("Hide the Icon in the image Overlay on Hover", 'boc-shortcodes-and-widgets'),
				
				"group"			=> "Design",
			),
			array(
				"type"			=> 'dropdown',
				"heading" 		=> esc_html__("Hover Image Effect", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "img_hover_effect",
				"value"			=> Array("None" => '', "Zoom Out" => 1, "Zoom In" => 2, "Side" => 3, "Spin" => 4),
				"description" 	=> esc_html__("Pick a hover Image Effect", 'boc-shortcodes-and-widgets'),
				"group"			=> "Images",
			),
			array(
				'type'			=> "textfield",
				"heading"		=> esc_html__( "Overwrite Image Width", 'boc-shortcodes-and-widgets'),
				'param_name'	=> "img_width",
				'std'			=> "",
				'description'	=> esc_html__( "Enter a width in pixels if you want to overwrite the default (600x380). Both W and H should be changed to define a new dimension. Leave empty for default.", 'boc-shortcodes-and-widgets'),
				'group'			=> "Images",
			),
			array(
				'type'			=> "textfield",
				"heading"		=> esc_html__( "Overwrite Image Height", 'boc-shortcodes-and-widgets'),
				'param_name'	=> "img_height",
				'std'			=> "",
				'description'	=> esc_html__( 'Enter a height in pixels if you want to overwrite the default (380). Both W and H should be changed to define a new dimension. Leave empty for default.', 'boc-shortcodes-and-widgets'),
				'group'			=> "Images",
			),
	   )
	));
}