<?php

/**
	Post Carousel
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_posts_carousel' ) ) {
	
	function shortcode_boc_posts_carousel($atts, $content = null) {
		
		$atts = vc_map_get_attributes('boc_posts_carousel', $atts );
		extract( $atts );	

		// Arrows
		$nav = (($navigation == "Arrows") || ($navigation == "Both"));
		if ($nav && ($arrows_position!='top')) {
			$css_classes .= ' owl_side_arrows';
		}
		
		// Img Hover Effect
		if ($img_hover_effect) {
			$img_hover_effect = ' img_hover_effect'.$img_hover_effect;
		}
		
		// CSS Animation
		$css_animation_classes = "";
		if ( $css_items_animation != '' ) {
			$css_animation_classes = 'boc_animate_when_almost_visible boc_'. $css_items_animation .'';
		}		
		
		// Dots
		$dots = (($navigation == "Dots") || ($navigation == "Both"));
		if($dots){
			$css_classes .= ' has_dots'; 
		}	

				
		$exclude_post = 0;
		if($exclude_current){
			$exclude_post = get_the_ID();
		}	
		
		$args = array(
				'post_type' 	=> array($post_type),
			//	'category_name' => ($category_slug ? $category_slug : null),  # MOVED TO BOTTOM IF Statement
				'orderby'		=> $order_by,
				'order'			=> $order,
				'showposts' 	=> $limit,
				'post__not_in' 	=> array($exclude_post),
		);
		
		//  WPML compatibility
		if($category_slug) {
			$args['tax_query'] = array(
			  array(
				'taxonomy' => 'category',
				'field' => 'slug',
				'terms' => (explode( "," , str_replace(' ', '', $category_slug))),
			  )
			);
		}
		
		
		$wp_query = new WP_Query($args);
		
		$str = '';

		if ($wp_query->have_posts()):
			
			// generate checksum of $atts array
			$carousel_id = rand(0,100000);
			
			$str = '<div class="posts_carousel_holder '.esc_attr($css_classes).'">
						<div id="posts_carousel_'.$carousel_id.'" style="opacity:0;">';
			
			while( $wp_query->have_posts() ) : $wp_query->the_post();
				//$large_image_url = wp_get_attachment_image_src( get_post_thumbnail_id($wp_query->post->ID), 'boc_medium'); 
				$excerpt = get_the_excerpt();
				$short_excerpt = wp_trim_words($excerpt,$excerpt_word_limit);
				$str .='<div class="post_item_block '.esc_attr($css_animation_classes).' '.(!$css_animation_classes ? "boc_owl_lazy" : "").' '.(($design_preset == 'metro') ? "white_links ". esc_attr($img_hover_effect): "").' '.$design_preset.' '.(($design_preset == "boxed") ? $boxed_style : "").'">';
				$id = $wp_query->post->ID;

				// Show Featured Image
				if( function_exists( 'get_post_format' ) && $show_pic){
					if($img_width && $img_height){

						$featured_img_url	= wp_get_attachment_url( get_post_thumbnail_id() );
						$thumbnail_hard_crop = true;
						$feat_img = aq_resize( $featured_img_url, intval($img_width), intval($img_height), $thumbnail_hard_crop );
						
					}else{

						$feat_img_arr = wp_get_attachment_image_src( get_post_thumbnail_id(), 'boc_medium');
						$feat_img = $feat_img_arr[0];
					}
					
					// If image isset
					if($feat_img){					
						$str .='<div class="pic '.esc_attr($img_hover_effect).'"><a href="'. get_permalink().'"><img src="'.esc_url($feat_img).'"/><div class="img_overlay"><span class="hover_icon icon_plus"></span></div></a></div>'; 
					}elseif($design_preset == 'metro'){
						$str .='<div class="pic '.esc_attr($img_hover_effect).'"><a href="'. get_permalink().'"><img src="'.get_template_directory_uri().'/images/no_img.jpg"/><div class="img_overlay"><span class="hover_icon icon_plus"></span></div></a></div>'; 						
					}
				}

				$str .= '<div class="post_item_desc">';

				// Meta
				$meta_str = '';
				if($show_meta) {
					$meta_str .= '<div class="post_block_post_meta '.($bordered_meta?"bordered":"").' clearfix">';
					$meta_str .= ($show_author) ? '<a href="'.get_author_posts_url(get_the_author_meta("ID")).'" class="post_block_post_author"><span class="post_author">'.get_avatar(get_the_author_meta("user_email"), "20").' '.esc_html__('by','boc-shortcodes-and-widgets').' '.get_the_author_meta("nickname").'</span></a>' : '';
					$meta_str .= ($show_date) ? '<span class="post_date"><span class="blog_icon boc_i-clock-outline"></span>'.boc_post_date().'</span>' : '';
					$meta_str .= ($show_like_button) ? ((ot_get_option('posts_like_functionality','on')=='on') ? get_simple_likes_button( $id ) : '') : '';
					$meta_str .= ($show_comments) ? '<span class="post_comments"><a href="'.get_comments_link( $wp_query->post->ID ).'"><span class="blog_icon blog_icon boc_i-comment-bubble"></span>'.$wp_query->post->comment_count.'</a></span>' : '';
					$meta_str .= '</div>';
				}
				

				// Show date according to style
				$str .= (($show_meta == 1) ? $meta_str : "");
				
				$str .='<h4 class="dark_links"><a href="'. get_permalink().'">'.esc_html(get_the_title()).'</a></h4>';
				$str .= (($show_meta == 2) ? $meta_str : "");
				$str .= ($show_excerpt && ($design_preset != 'metro') ? '<p>'.$short_excerpt.'</p>': '');
				$str .= (($show_meta == 3) ? $meta_str : "");
				$str .= ($show_read_more ? '<div class="more-link'.$read_more_style.' '.($bordered_read_more?"bordered":"").'"><a href="'. get_permalink().'">'.esc_html__('Read more','boc-shortcodes-and-widgets').'</a></div>' : '');

				$str .='		</div>
				</div>';
			endwhile;  // close the Loop
			
			wp_reset_postdata();
					
			$str .='</div></div>';
					

			$js = '
				/* Posts Carousel :: START */
				jQuery(document).ready(function($) {			
							
					// Load carousel after its images are loaded
					boc_preloadImages($("#posts_carousel_'.$carousel_id.' img"), function () {
						
						var carousel = $("#posts_carousel_'.$carousel_id.'");
						
						var args = {
							items: 				'.(int)$items_visible.',
							autoplay:			'.($autoplay ? "true" : "false").',
							autoplayTimeout:	'.(int)$autoplay_interval.',
							loop: 				'.($loop	? "true" : "false").',
							nav: 				'.($nav		? "true" : "false").',
							dots: 				'.($dots	? "true" : "false").',
							autoHeight: 		'.(($auto_height && ($items_visible==1)) ? "true" : "false").',
							navText:			'.(($nav && ($arrows_position!='top')) ? 
							"[\"<span class='icon boc_i-angle-". (is_rtl() ? 'right' : 'left') ."-circle'></span>\",\"<span class='icon boc_i-angle-". (is_rtl() ? 'left' : 'right') ."-circle'></span>\"]" : 
							"[\"<span class='icon boc_i-arrow-point-to-". (is_rtl() ? 'right' : 'left') ."'></span>\",\"<span class='icon boc_i-arrow-point-to-". (is_rtl() ? 'left' : 'right') ."'></span>\"]").',
							slideBy: 			'.(int)$items_slided.',
							
							navRewind: false,
							rtl : 				' . (is_rtl() ? 'true' : 'false') . ',
							margin:30,
							responsive:{
								0:{
								  items:1,
								},
								480:{
								  items:1,
								  margin:20,
								},
								769:{
								  items:'.(int)$items_visible.'
								}
							},
							onInitialized:  showCarousel_'.$carousel_id.',
							onTranslated:  carousel_translated_'.$carousel_id.'
						};

						carousel.owlCarousel(args);

						var initital_width = carousel.css("width");
						
						/* Refresh it for full width rows */
						$(window).load(function(){
							if(carousel.css("width") != initital_width) {
								carousel.trigger("destroy.owl.carousel").removeClass("owl-carousel owl-loaded");
								carousel.find(".owl-stage-outer").children().unwrap();
								carousel.owlCarousel(args);
							}
						});
					});
					
					
					/* Show once loaded */
					function showCarousel_'.$carousel_id.'() {
						
						
						// Set Custom Waypoints timing for each item
						var inactive_item_index = 0;
						$("#posts_carousel_'.$carousel_id.' .owl-item .boc_animate_when_almost_visible.post_item_block:not(.boc_start_animation)").each(function (i, e) {
								
								var delay = 160;
								
								if($(this).parent().hasClass("active")){
									$(e).trans(i * delay + "ms", "-delay");
								}else {
									$(e).trans(inactive_item_index * delay + "ms", "-delay");
									inactive_item_index++;
								}
						});
						
						
						$("#posts_carousel_'.$carousel_id.'").fadeTo(0,1);
						$("#posts_carousel_'.$carousel_id.' .owl-item .boc_owl_lazy").css("opacity","1");
					}
					
					/* Translated */
					function carousel_translated_'.$carousel_id.'() {
						$("#posts_carousel_'.$carousel_id.' .owl-item.active .boc_animate_when_almost_visible.post_item_block:not(.boc_start_animation)").addClass("boc_start_animation");
					}
				});
				/* Posts Carousel :: END */';

			wp_enqueue_script( 'boc_shortcodes_script');
			wp_add_inline_script( 'boc_shortcodes_script', $js );					

		endif;
		wp_reset_postdata();

		return $str;
	}
	
	add_shortcode('boc_posts_carousel', 'shortcode_boc_posts_carousel');
}




// Map Shortcode in Visual Composer
vc_map( array(
   "name" 		=> esc_html__("Post Carousel", 'boc-shortcodes-and-widgets'),
   "base" 		=> "boc_posts_carousel",
   "category" 	=> "Alea Shortcodes",
   "icon" 		=> "boc_posts_carousel",
   "weight"		=> 40,
   "params" 	=> array(
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Total Visible Items", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "items_visible",
			"value" 		=> Array(1,2,3,4,5,6),
			"std"			=> "3",
			"description" 	=> esc_html__("How many items you want the viewport to be consisted of.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Slide Items at once", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "items_slided",
			"value" 		=> Array(1,2,3,4,5,6),
			"std"			=> "1",
			"description" 	=> esc_html__("How many items will slide per click.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),			
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Slider Navigation", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "navigation",
			"value"			=> Array("Arrows", "Dots", "Both"),
			"description" 	=> esc_html__("Select a Navigation Type", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Arrows Position", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "arrows_position",
			"value"			=> Array("Top"=>"top", "Side"=>"side"),
			"description" 	=> esc_html__("Select Position of Carousel Arrows. Top arrows are absolutely positioned above the carousel!", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "navigation",
					'value'		=> Array("Arrows", "Both"),
			),
			"group"			=> "Slider Settings",
		),			
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("AutoPlay the slider?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "autoplay",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Testimonial Slider to autoplay", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",						
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("AutoPlay Interval", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "autoplay_interval",
			"value" 		=> array('4000','6000','8000','10000','12000','14000'),
			"std"			=> "6000",
			"description" 	=> esc_html__("Set the Autoplay Interval (miliseconds).", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "autoplay",
					'not_empty'	=> true,
			),
			"group"			=> "Slider Settings",
		),			
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Loop the slider", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "loop",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Slider to be Infinite", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",							
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Enable AutoHeight", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "auto_height",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes for an AutoHeight slider - it will resize according to the item heights in sight. Works fine only when Visible Items equals '1'.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "items_visible",
					'value'		=> "1",
			),
			"group"			=> "Slider Settings",
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_items_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_blur"),
			"description"	=> esc_html__("Animation will be applied to each single Item in your grid for a better effect", "boc-shortcodes-and-widgets"),
			"group"			=> "Slider Settings",
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),			
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Post Type Filter", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "post_type",
			"admin_label"	=> true,
			"value" 		=> "post",
			"description" 	=> esc_html__("Filter only a certain Post Type. Could be used for Custom Post Types as well. Default is 'post'.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Category Slug Filter", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "category_slug",
			"value" 		=> "",
			"description" 	=> esc_html__("Filter only a certain Category Slug from the specified Post Type. You can list more than one (comma-separated).", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),				
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("'Order By' Clause", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "order_by",
			"value" 		=> array('none','ID','title','name','date','rand'),
			"std"			=> 'date',
			"description" 	=> __("Order results by a certain field. <a href='http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters' target='_blank'>More on the available WP options here</a>.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("'Order' Clause", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "order",
			"value" 		=> array('DESC','ASC'),
			"description" 	=> __("Order results in a Descending or Ascending order. <a href='http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters' target='_blank'>More on the order here</a>.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Exclude current post", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "exclude_current",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Useful when using the carousel in a Post to show related post items for example.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Query",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Max Number of Items in Carousel", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "limit",
			"value" 		=> Array(1,2,3,4,5,6,7,8,9,10,12,16,20,40),
			"std"			=> "10",
			"description" 	=> esc_html__("How many items you want to limit your carousel to. Default is  10.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Design",
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("Design Preset", "boc-shortcodes-and-widgets"),
			"param_name"	=> "design_preset",				
			"value"			=> array(
				esc_html__("Simple", "boc-shortcodes-and-widgets")		=> "simple",
				esc_html__("Boxed", "boc-shortcodes-and-widgets")			=> "boxed",
				esc_html__("Metro", "boc-shortcodes-and-widgets")			=> "metro",
			),
			"std"			=> "boxed",
			"edit_field_class" =>"vc_col-sm-6",
			"group"			=> "Design",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Boxed Items style", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "boxed_style",
			"value"			=> Array(esc_html__("Simple", "boc-shortcodes-and-widgets") => '0', esc_html__("Bordered", "boc-shortcodes-and-widgets") => 'boxed_bordered', esc_html__("Shadowed", "boc-shortcodes-and-widgets") => 'boxed_shadowed'),
			"std"			=> "boxed_bordered",
			"edit_field_class" =>"vc_col-sm-6",
			"dependency"	=> Array(
					'element'	=> "design_preset",
					'value'		=> array( 'boxed')
			),
			"group"			=> "Design",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Show Post Meta Data", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_meta",
			"value" 		=> Array("Don't show" => 0, "Above Title" => 1, "Below Title" =>2, "Below Excerpt" =>3 ),
			"std"			=> "1",
			"description" 	=> esc_html__("Display Meta data like 'Date', 'Comments', 'Like Button',", 'boc-shortcodes-and-widgets'),
			"group"			=> "Design",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Author in Meta", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_author",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",			
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Date in Meta", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_date",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"edit_field_class" =>"vc_col-sm-6",			
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Comments in Meta", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_comments",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",			
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Like Button in Meta", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_like_button",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"edit_field_class" =>"vc_col-sm-6",			
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Add Top Border to Meta Data", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "bordered_meta",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"group"			=> "Design",
			"dependency"	=> Array(
					'element'	=> "show_meta",
					'value'		=> array( '1', '2', '3' )
			),
		),		
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show Excerpt", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_excerpt",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"description" 	=> esc_html__("Set to Yes if you want an excerpt from each post to be displayed.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "design_preset",
					'value'		=> array( 'simple','boxed')
			),			
			"group"			=> "Design",
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Excerpt Word limit", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "excerpt_word_limit",
			"value" 		=> "55",
			"description" 	=> __("How many words you want to further limit your excerpt to? (Default is 55. <a href='https://www.youtube.com/watch?v=Vp6pDsRCYfI' target='_blank'>How to add custom excerpts</a>)", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
				'element'	=> "show_excerpt",
				'not_empty'	=> true,
			),
			"group"			=> "Design",
		),		
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Show 'Read More' link", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_read_more",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want a 'Read More' link below each item in the carousel.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "design_preset",
					'value'		=> array( 'simple','boxed')
			),			
			"group"			=> "Design",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Add Top Border to Read More link", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "bordered_read_more",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"group"			=> "Design",
			"dependency"	=> Array(
				'element'	=> "show_read_more",
				'not_empty'	=> true,
			),
		),		
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("'Read More' link style", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "read_more_style",
			"value"			=> Array(esc_html__("Simple", "boc-shortcodes-and-widgets") => '0', esc_html__("With Arrow icon", "boc-shortcodes-and-widgets") => '1'),
			"description" 	=> esc_html__("Pick a style for your 'Read More' link.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "show_read_more",
					'value'		=> "yes",
			),
			"std"			=> "0",
			"group"			=> "Design",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Show Featured Image", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_pic",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"std"			=> "yes",
			"description" 	=> esc_html__("Set to Yes if you want the Featured Images of displayed posts to be shown", 'boc-shortcodes-and-widgets'),
			"group"			=> "Images",
		),
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Hover Image Effect", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "img_hover_effect",
			"value"			=> Array("None" => '', "Zoom Out" => 1, "Zoom In" => 2, "Side" => 3, "Spin" => 4),
			"description" 	=> esc_html__("Pick a hover Image Effect", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "show_pic",
					'value'		=> "yes",
			),
			"group"			=> "Images",
		),
		array(
			'type'			=> "textfield",
			"heading"		=> esc_html__( "Overwrite Image Width", 'boc-shortcodes-and-widgets'),
			'param_name'	=> "img_width",
			'value'			=> "",
			'description'	=> esc_html__( "Enter a width in pixels if you want to overwrite the default (460). Leave empty for default.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "show_pic",
					'value'		=> "yes",
			),
			'group'			=> "Images",
		),
		array(
			'type'			=> "textfield",
			"heading"		=> esc_html__( "Overwrite Image Height", 'boc-shortcodes-and-widgets'),
			'param_name'	=> "img_height",
			'value'			=> "",
			'description'	=> esc_html__( 'Enter a height in pixels if you want to overwrite the default (290). Leave empty for default.', 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "show_pic",
					'value'		=> "yes" ,
			),
			'group'			=> "Images",
		),
   )
));