<?php

/**
	Testimonial Slider
**/

// Register Shortcodes
if( ! function_exists( 'shortcode_boc_testimonials' ) ) {
	function shortcode_boc_testimonials($atts, $content = null) {
		
		$atts = vc_map_get_attributes('boc_testimonials', $atts );
		extract( $atts );	

		// Animation Type
		if ($animation == 'Slide') {
			$anim_out = "false";
			$anim_in = "false";
		} elseif ($animation == 'Fade') {
			$anim_out = "\"fadeOut\"";
			$anim_in = "\"fadeIn\"";
		} elseif ($animation == 'Bottom-Top') {
			$anim_out = "\"fadeOutDown\"";
			$anim_in = "\"fadeInUp\"";
		} elseif ($animation == 'Flip') {
			$anim_out = "\"fadeOutDown\"";
			$anim_in = "\"flipInX\"";
		}
		
		// Arrows
		$nav = (($navigation == "arrows") || ($navigation == "arrows_dots") || ($navigation == "arrows_faces"));
		
		// Dots
		$dots = (($navigation == "dots") || ($navigation == "arrows_dots"));
		
		// Faces
		$faces_nav = (($navigation == "faces") || ($navigation == "arrows_faces"));
		
		$classes = 	($nav 			? ' owl_has_arrow_nav'	: '').
					($dots 			? ' owl_has_dot_nav'	: '').
					($faces_nav		? ' has_faces_nav'	: '').
					($style			? ' testimonial_style_'.$style : '').
					((($style=="small") && !$is_3d) 	? ' is_2d' 		: '').
					((($style=="big") && $is_minimal)	? ' is_minimal' : '').
					($css_classes	? ' '.$css_classes : '');
					

		$carousel_id = rand(0,100000);
		
		$str='';        
		$str .= '<!-- Testimonials -->
				<div class="testimonials">
					<div id="testimonial_carousel_'.$carousel_id.'" style="opacity: 0;" class="testimonials_carousel '.esc_attr($classes).'">';

		$str .= do_shortcode($content);
		
		$str .= '</div>
				</div>
				<!-- Testimonials::END -->';			 
		
		$js = '
			/* Testimonials Carousel :: START */
			jQuery(document).ready(function($) {

				var carousel = $("#testimonial_carousel_'.$carousel_id.'");

				if(carousel.hasClass("has_faces_nav")){
					carousel.on("initialized.owl.carousel", function(e) {
						carousel.append("<div class=\"section\"><div class=\"faces_nav\"></div></div>");					
						carousel.find(".testimonial_quote").each( function(i, el) {
							if(!$(this).parent(".owl-item").hasClass("cloned")){
								var face_img = $(this).find("img").first().clone();
								var nav_item_class = "";
								
								if(i==0){
									nav_item_class += " active_face";
								}
								var face_html = $("<div class=\"face_nav_item "+ nav_item_class +"\"></div>");
								face_html.append(face_img);

								carousel.find(".faces_nav").append(face_html);
							}
						});
					});
				}

				var args = {
					onInitialized:  		bocShowTestimonialCarousel_'.$carousel_id.',
					items: 1,
					autoplay:			'.($autoplay	? 'true': 'false').',
					autoplayTimeout:	'.(int)$autoplay_interval.',
					loop: 				'.($loop 		? 'true': 'false').',
					nav: 				'.($nav 		? 'true': 'false').',
					dots: 				'.($dots||$faces_nav ? 'true': 'false').',
					autoHeight: 			'.($auto_height	? 'true': 'false').',
					navText:				'.($style=="big" ?
						'["<span class=\'boc_arrow boc_arrow_' . (is_rtl() ? 'right' : 'left') . '\'></span>","<span class=\'boc_arrow boc_arrow_' . (is_rtl() ? 'left' : 'right') . '\'></span>"]' :
						'["<span class=\'icon fa fa-angle-' . (is_rtl() ? 'right' : 'left') . '\'></span>","<span class=\'icon fa fa-angle-' . (is_rtl() ? 'left' : 'right') . '\'></span>"]').',
					navRewind: false,
					rtl: 				' . (is_rtl() ? 'true' : 'false') . ',
					smartSpeed:			600,
					margin: 				10,					
					animateOut: 		'.$anim_out.',
					animateIn: 			'.$anim_in.',
				};

				carousel.owlCarousel(args);


				// Attach events to Custom Icons Nav
				carousel.find(".face_nav_item").each( function(i, el) {
					$(this).on("click",function(){
						carousel.find(".face_nav_item").removeClass("active_face");
						$(this).addClass("active_face");
						carousel.trigger("to.owl.carousel", i);
					});
				});
				// Call back to set Active Icon Nav 
				carousel.on("changed.owl.carousel",function(e) {
					carousel.find(".face_nav_item").each( function(i, el) {
						if(i == e.item.index) {
							carousel.find(".face_nav_item").removeClass("active_face");
							$(this).addClass("active_face");
						}
					});
				});

				var initital_width = carousel.css("width");

				/* Refresh it for full width rows */
				$(window).load(function(){
					if(carousel.css("width") != initital_width) {
						carousel.trigger("destroy.owl.carousel").removeClass("owl-carousel owl-loaded");
						carousel.find(".owl-stage-outer").children().unwrap();
						carousel.owlCarousel(args);
					}
				});
				
				/* Show once loaded */
				function bocShowTestimonialCarousel_'.$carousel_id.'(){
					carousel.fadeTo(1000,1);
					jQuery("#testimonial_carousel_'.$carousel_id.' .owl-item .boc_owl_lazy").css("opacity","1");
				}

			});
			/* Testimonials Carousel :: END */';
			
		wp_enqueue_script( 'boc_shortcodes_script');
		wp_add_inline_script( 'boc_shortcodes_script', $js );	

		return $str;
	}
	
	add_shortcode('boc_testimonials', 'shortcode_boc_testimonials');
}

// Single Testimonial
if( ! function_exists( 'shortcode_boc_testimonial' ) ) {
	function shortcode_boc_testimonial($atts, $content = null) {
		
		$atts = vc_map_get_attributes('boc_testimonial', $atts );
		extract( $atts );	
	
		// Adding a check for VC picture added
		$img = '';
		if($atts['picture_url']){
			$vc_image = wp_get_attachment_image($atts['picture_url'],'full');
			// If not passed via VC, we get the URL
			if($vc_image){
				$img = $vc_image;
			}
		}else {
			$img = '<img class="empty_user_testimonial_image" src="'.get_template_directory_uri().'/images/user.png" />';
		}
		
		$str = '';
		$str .= '	<div class="testimonial_quote boc_owl_lazy">
						<div class="quote_content">
							<p>'.$content.'</p>
							<span class="quote_arrow"></span>
						</div>
						<div class="quote_author heading_font">'.$img.'<div class="icon_testimonial">'.$atts['author'].'</div><span class="quote_author_description">'.$atts['author_title'].'</span>	</div>
					</div>';

		return $str;
	}
	
	add_shortcode('boc_testimonial', 'shortcode_boc_testimonial');
}

// Map Shortcodes in Visual Composer
vc_map( array(
	"name" => esc_html__("Testimonial Slider", 'boc-shortcodes-and-widgets'),
	"base" => "boc_testimonials",
	"as_parent" => array('only' => 'boc_testimonial'), // Use only|except attributes to limit child shortcodes (separate multiple values with comma)
	"content_element" => true,
	"icon" 		=> "boc_testimonials",
	"category" => "Alea Shortcodes",
	"show_settings_on_create" => true,
	"weight"	=> 45,
	"params" => array(
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Design Style", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "style",
			"value"			=> Array("Big-Centered" => 'big',"Small-Boxed" => 'small'),
			"description" 	=> esc_html__("Select your Testimonial Slider Style", 'boc-shortcodes-and-widgets'),
		),	
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Is small boxed testimonial 3d style?", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "is_3d",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want the 3d style for your small-boxed testimonial slider.", 'boc-shortcodes-and-widgets'),
			"dependency"		=> Array(
				'element'	=> "style",
				'value'		=> Array("small"),
			),				
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Is Big-Centered minimal style activated?", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "is_minimal",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want the minimal style for your Big Centered testimonial slider.", 'boc-shortcodes-and-widgets'),
			"dependency"		=> Array(
				'element'	=> "style",
				'value'		=> Array("big"),
			),				
		),
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Slider Navigation", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "navigation",
			"value"			=> Array(
					"Arrows" 		=> 	"arrows", 
					"Dots"			=>	"dots", 
					"Arrows & Dots"	=>	"arrows_dots",  
					"Faces"			=>	"faces",
					"Arrows & Faces"=>	"arrows_faces"
			),
			"std"			=> "Arrows",
			"description" 	=> esc_html__("Select a Navigation Type", 'boc-shortcodes-and-widgets'),
		),
	
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Animation Type", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "animation",
			"value" 			=> array('Slide', 'Fade', 'Bottom-Top', 'Flip'),
			"description" 	=> esc_html__("Set your Animation type", 'boc-shortcodes-and-widgets'),
		),		
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("AutoPlay the slider?", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "autoplay",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes'),
			"description" 	=> esc_html__("Set to Yes if you want your Testimonial Slider to autoplay", 'boc-shortcodes-and-widgets'),					
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("AutoPlay Interval", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "autoplay_interval",
			"value" 			=> array('4000','6000','8000','10000','12000','14000'),
			"std"			=> "6000",
			"description" 	=> esc_html__("Set the Autoplay Interval (miliseconds).", 'boc-shortcodes-and-widgets'),
			"dependency"		=> Array(
					'element'	=> "autoplay",
					'not_empty'	=> true,
			),				
		),			
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Loop the slider", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "loop",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Slider to be Infinite (won't work with Faces nav)", 'boc-shortcodes-and-widgets'),								
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Enable AutoHeight", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "auto_height",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes for an AutoHeight slider - it will resize according to the item heights in sight", 'boc-shortcodes-and-widgets'),	
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
		
	),
	"js_view" => 'VcColumnView'
) );

vc_map( array(
	"name" => esc_html__("Testimonial Item", 'boc-shortcodes-and-widgets'),
	"base" => "boc_testimonial",
	"content_element" => true,
	"as_child" => array('only' => 'boc_testimonials'), // Use only|except attributes to limit parent (separate multiple values with comma)
	"content_element" => true,
	"icon" 	=> "boc_testimonials",
	"params" => array(
		array(
			"type" => "textfield",
			"heading" => esc_html__("Text", 'boc-shortcodes-and-widgets'),
			"param_name" => "content",
			"value" => esc_html__("Testimonial Text", 'boc-shortcodes-and-widgets'),
			"description" => esc_html__("Enter the text for your Testimonial", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" => "textfield",
			"heading" => esc_html__("Testimonial Author", 'boc-shortcodes-and-widgets'),
			"param_name" => "author",
			"value" => esc_html__("Lindsay Ford", 'boc-shortcodes-and-widgets'),
			"admin_label"	=> true,
			"description" => esc_html__("Enter author name", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" => "textfield",
			"heading" => esc_html__("Testimonial Author Title", 'boc-shortcodes-and-widgets'),
			"value" => esc_html__("Designer", 'boc-shortcodes-and-widgets'),
			"param_name" => "author_title",
			"description" => esc_html__("Enter author title", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" => "attach_image",
			"heading" => esc_html__("Picture", 'boc-shortcodes-and-widgets'),
			"param_name" => "picture_url",
			"description" => esc_html__("Add Testimonial Image", 'boc-shortcodes-and-widgets'),
		),
	)
));

if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_boc_testimonials extends WPBakeryShortCodesContainer {
	}
}
if ( class_exists( 'WPBakeryShortCode' ) ) {
	class WPBakeryShortCode_boc_testimonial extends WPBakeryShortCode {
	}
}