<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

/**
 * Shortcode attributes
 * @var $atts
 * @var $el_class
 * @var $full_width
 * @var $full_height
 * @var $equal_height
 * @var $columns_placement
 * @var $content_placement
 * @var $parallax
 * @var $parallax_image
 * @var $css
 * @var $el_id
 * @var $video_bg
 * @var $video_bg_url
 * @var $video_bg_parallax
 * @var $parallax_speed_bg
 * @var $parallax_speed_video
 * @var $content - shortcode content
 * @var $css_animation
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_Row
 */
$el_class = $full_height = $parallax_speed_bg = $parallax_speed_video = $full_width = $equal_height = $flex_row = $columns_placement = $content_placement = $parallax = $parallax_image = $css = $el_id = $video_bg = $video_bg_url = $video_bg_parallax = $css_animation = '';
$disable_element = '';
$output = $after_output = '';
$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );

wp_enqueue_script( 'wpb_composer_front_js' );

$el_class = $this->getExtraClass( $el_class ) . $this->getCSSAnimation( $css_animation );

$css_classes = array(
	'vc_row',
	'wpb_row',
	//deprecated
	'vc_row-fluid',
	$el_class,
	vc_shortcode_custom_css_class( $css ),
);

if ( 'yes' === $disable_element ) {
	if ( vc_is_page_editable() ) {
		$css_classes[] = 'vc_hidden-lg vc_hidden-xs vc_hidden-sm vc_hidden-md';
	} else {
		return '';
	}
}

if ( vc_shortcode_custom_css_has_property( $css, array(
		'border',
		'background',
	) ) || $video_bg || $parallax
) {
	$css_classes[] = 'vc_row-has-fill';
}

if ( ! empty( $atts['gap'] ) ) {
	$css_classes[] = 'vc_column-gap-' . $atts['gap'];
}

$wrapper_attributes = array();
// build attributes for wrapper
if ( ! empty( $el_id ) ) {
	$wrapper_attributes[] = 'id="' . esc_attr( $el_id ) . '"';
	// BOC - enqueue particles.js if needed
	if(esc_attr( $el_id ) == 'particles_animation') {
		wp_enqueue_script('alea-particles', get_template_directory_uri().'/js/particles.js', array('jquery'));
	}
}
if ( ! empty( $full_width ) ) {
	$wrapper_attributes[] = 'data-vc-full-width="true"';
	$wrapper_attributes[] = 'data-vc-full-width-init="false"';
	if ( 'stretch_row_content' === $full_width ) {
		$wrapper_attributes[] = 'data-vc-stretch-content="true"';
	} elseif ( 'stretch_row_content_no_spaces' === $full_width ) {
		$wrapper_attributes[] = 'data-vc-stretch-content="true"';
		$css_classes[] = 'vc_row-no-padding';
	}
	$after_output .= '<div class="vc_row-full-width vc_clearfix"></div>';
}

if ( ! empty( $full_height ) ) {
	$css_classes[] = 'vc_row-o-full-height';
	if ( ! empty( $columns_placement ) ) {
		$flex_row = true;
		$css_classes[] = 'vc_row-o-columns-' . $columns_placement;
		if ( 'stretch' === $columns_placement ) {
			$css_classes[] = 'vc_row-o-equal-height';
		}
	}
}

if ( ! empty( $equal_height ) ) {
	$flex_row = true;
	$css_classes[] = 'vc_row-o-equal-height';
}

if ( ! empty( $content_placement ) ) {
	$flex_row = true;
	$css_classes[] = 'vc_row-o-content-' . $content_placement;
}

if ( ! empty( $flex_row ) ) {
	$css_classes[] = 'vc_row-flex';
}

$has_video_bg = ( ! empty( $video_bg ) && ! empty( $video_bg_url ) && vc_extract_youtube_id( $video_bg_url ) );

$parallax_speed = $parallax_speed_bg;
if ( $has_video_bg ) {
	$parallax = $video_bg_parallax;
	$parallax_speed = $parallax_speed_video;
	$parallax_image = $video_bg_url;
	$css_classes[] = 'vc_video-bg-container';
	wp_enqueue_script( 'vc_youtube_iframe_api_js' );
}

if ( ! empty( $parallax ) ) {
	wp_enqueue_script( 'vc_jquery_skrollr_js' );
	$wrapper_attributes[] = 'data-vc-parallax="' . esc_attr( $parallax_speed ) . '"'; // parallax speed
	$css_classes[] = 'vc_general vc_parallax vc_parallax-' . $parallax;
	if ( false !== strpos( $parallax, 'fade' ) ) {
		$css_classes[] = 'js-vc_parallax-o-fade';
		$wrapper_attributes[] = 'data-vc-parallax-o-fade="on"';
	} elseif ( false !== strpos( $parallax, 'fixed' ) ) {
		$css_classes[] = 'js-vc_parallax-o-fixed';
	}
}

if ( ! empty( $parallax_image ) ) {
	if ( $has_video_bg ) {
		$parallax_image_src = $parallax_image;
	} else {
		$parallax_image_id = preg_replace( '/[^\d]/', '', $parallax_image );
		$parallax_image_src = wp_get_attachment_image_src( $parallax_image_id, 'full' );
		if ( ! empty( $parallax_image_src[0] ) ) {
			$parallax_image_src = $parallax_image_src[0];
		}
	}
	$wrapper_attributes[] = 'data-vc-parallax-image="' . esc_attr( $parallax_image_src ) . '"';
}
if ( ! $parallax && $has_video_bg ) {
	$wrapper_attributes[] = 'data-vc-video-bg="' . esc_attr( $video_bg_url ) . '"';
}

/* BOC - start */
$overlay_output = '';
if ( ! empty( $boc_overlay_color ) ) {
	$css_classes[] = 'boc_row_with_overlay';
	
	// If not gradient
	if ( 'yes' != $boc_with_gradient ) {
		$overlay_style = "style='background:" . esc_attr($boc_overlay_color)."';";
	} else {
		$boc_overlay_color2 = !empty($boc_overlay_color2) ? esc_attr($boc_overlay_color2) : "rgba(0,0,0,0)"; 
		$overlay_style = "style='background: linear-gradient(".esc_attr($boc_overlay_gradient_angle).", ".$boc_overlay_color2." 0%, ".esc_attr($boc_overlay_color)." 100%);'";
	}
	
	$overlay_output = '<div class="boc_overlay" '.$overlay_style.'></div>';
}
if ( 'yes' == $boc_add_shape_border ) {
	
	$css_classes[] = 'boc_row_with_shape_border';
	
	$boc_shape_border_count = esc_attr($boc_shape_border_position) == 'both' ? 2 : 1;
    $boc_shape_border_pos = (esc_attr($boc_shape_border_position) == 'both') ? array('top','bottom') : array($boc_shape_border_position);


	for($i=0; $i<$boc_shape_border_count;$i++) {
		
		$overlay_output .= '<div class="boc_shape_border '.$boc_shape_border_pos[$i].' '.('yes' == $boc_shape_border_front ? "boc_shape_border_to_front" : "" ).'" style="height: '.(int)esc_attr($boc_shape_border_height).'px;">';
		switch (esc_attr($boc_shape_border_type)){

			case 'wave':
				$overlay_output .= '<svg xmlns="http://www.w3.org/2000/svg" fill="'.esc_attr($boc_shape_border_color).'" preserveAspectRatio="none" viewBox="0 0 1443 88" >
			<path d="M1446.63,88H0c0,0,0-33.4,0-33.41C75.4,69.1,201,85.3,357.6,85 c291,0,357-46,660-45.7c233.75,0,327,4.8,429,14.607C1446.6,73.6,1446.6,88,1446.6,88z"/>
			<path opacity="0.5" d="M1558.032,88h-1590.5c0,0-15-52-15-52	C30.5,58.6,165,85,324.8,85c296,0,381.2-53.5,691.78-61.85c238-6.3,438,4.12,541.4,16.82 C1558,65,1558,88,1558,88z"/>
			<path opacity="0.4" d="M1552,88H-87.5c0,0,0-73.5,0-73.5 c83.707,25,215,70,390,70c323,0,435-73,773-79C1175,3.06,1374,1,1552,16.5  C1552,49,1552,88,1552,88z"/>
			</svg>';
				break;

			case 'tilt_left':
				$overlay_output .= '<svg xmlns="http://www.w3.org/2000/svg" fill="'.esc_attr($boc_shape_border_color).'" preserveAspectRatio="none" viewBox="0 0 1000 167"><path d="M1000,1c-0,95-0,167-0,166H-10"/></svg>';
				break;

			case 'tilt_right':
				$overlay_output .= '<svg xmlns="http://www.w3.org/2000/svg" fill="'.esc_attr($boc_shape_border_color).'" preserveAspectRatio="none" viewBox="0 0 1000 167"><path d="M1000,166H0c0,0,0-71-0-167"/></svg>';
				break;
				
			case 'curve':
				$overlay_output .= '<svg xmlns="http://www.w3.org/2000/svg" fill="'.esc_attr($boc_shape_border_color).'" preserveAspectRatio="none" viewBox="-500 51 1000 167">
				<path d="M500,51c0,0-181,164-500,164c-321,0-500-164-500-164
	c0,96,0,167,0,167h-0h0h1000,0l0,0C500,217,500,146,500,50z"/></svg>';
				break;

			case 'triangle':
				$overlay_output .= '<svg xmlns="http://www.w3.org/2000/svg" fill="'.esc_attr($boc_shape_border_color).'" preserveAspectRatio="none" viewBox="0 532 1000 167">
	<path d="M1000.25,533.25l-500,163.5l-500-163.5c0.031,95.83,0.002,166.993,0.002,167H0.251h0.001h999.996l0,0l0,0
		C1000.248,700.243,1000.219,629.08,1000.25,533.25z"/>
	</svg></svg>';
				break;
			case 'grunge':
				$overlay_output .= '<svg xmlns="http://www.w3.org/2000/svg" fill="'.esc_attr($boc_shape_border_color).'" preserveAspectRatio="none" viewBox="0 20 1000 40">
	<path d="M555.9 41c-1 0 7 8.3 51.7 8.3 1 .7 6.1 0 8.2.7-1 0-4.1-.7-5.1 0 0 .7 2 0 4 .7 1 0 3.1.6 5.2.6 1 0 13.3 0 10.2-.6 1 0 2 0 3.1-.7-3 0-3 0-3-.7-3.2 0-6.2-.4-6.2-1.3 2-.7 6.1 0 7.1-.7 0 .7 3.1 0 5.2.7-1 0 0 .7 0 .7h3s1-.7 3.1-.7c0 .7 1 .7 2 1.3v.3h4.2c1 2 8.2 2 13.3 2.7v.6h2c0-.6 0-.6 1-1.3v-.7h3.1c-2 .7 3.1 2.7 6.2 1.4 0-1.4-3-.7-3-2 3 0 6 0 9.1-.7 0 .7 0 .7-1 .7h2v-.7c3.1 0 5.2.7 9.3 0 0 0-1 0-1 .7 2-1.4 3 0 7.1 0h3.1s0-.7 1 0c-1-.7-1-2-2-3.4 4 0 3-.6 6.1-.6v.6h12.3s0-.6-1-1.3h-3c-1.1-.7 1-.7 1-1.3H712c0-.7-1-1.4-3-1.4v2h-5.2c-1 0 0-.6 0-1.3-1 0-1 0-2-.7-1 0-4.2.7-2.1 1.4-2 0-7.2 0-8.2-.7 2 0 5.1 0 5.1-1.3-2 0-5.1 0-5.1-.7-3 0-10.2 0-12.3-.7 4.1-.6 12.3 0 16.4-1.3 6.1 0 7.2 0 12.3-.7v-.6h-1c4 0 6.1-.7 10.2-.7 0 0-1 0 0-.7h2l2.1-.6h3c5.2 0 13.4 0 14.4-1.4 2 0 5.2 1.4 8.2.7 0 .7 2 .7 3.1.7v-.7h9.2c-1-1.3-8.2-.7-11.2-1.3 0-.7 0-.7 1-2 7.1 0 11.2 1.3 17.4 1.3 0 .7 2 .7 2 1.3 2-.6 4.1 0 6.2.7 0 0 1-.7 1-1.3-1 0-2-1.4-1-2.7h-3c3 0 0-.7 0-1.3h6c22.6-3.4 28.8-1.4 53.3-2 2 0 2 1.3 5.2 2h3c0-.7-3 0-3-1.4 5-.6 15.3 0 21.5-1.3 1 .7 7.2 0 9.2 0h13.3c6.2 0 13.3 0 16.4-1.3 5.1 0 10.3.6 16.4.6 0 0-1-.6 0-.6 6.2.6 15.4 0 24.6 0h1c8.2 2 18.5 2 29.7 2.6 0 .3 0 0 1 .7 6.2.7 10.3 0 16.5 0-3.1 0 0 .7-1 1.3h-3.1c2 .7 8.2 0 11.2.7v-.7c4.1 0 6.2 0 7.2 1.4V60H0V20l39 2c8.1 0 17.4 0 25.5.7 0 .6-1 0-1 1.3 5.1 0 3.1 2 7.2 1.3v.7c5.1 0 11.3.7 18.4.7h19.5s1 .6 2 .6c4.2 0 7.2 0 10.3.7 1 0 2-.7 4.1 0 0 .7-2 .7-2 2h2c-1 .7-5.1 0-6.2 1.3 1 .7 0 0-2 0s-3 0-4.1 1.4c-6.1 0-8.2-1.4-15.4-1.4 0 .7 0 .7 1 1.4h3.1c0 .6 0 1.3 3.1 1.3H125v-.7c1-.6 5.1 0 5.1-2 2 0 2 0 2-.6 2.1 0 3.1 0 3.1-.7h2v2h1.1-6.1c0 .7 1 .7-1 2 1 0 1 .7 1 1.3 2 0 5-.6 3-2h7.2c2 0 5.1 0 6.2.7-2 0-3.1.7-3.1 2-2 0-2 0-3 .7h-3.2c2 0 2 0 1 .6 1 0 2.1.7 1 1.4-1 0-3 0-4 .6 1 .7 5.1.7 8.2 0 0 0 1 .7 2 .7 0-.7 1-2 2-2.7h2.1c0 1.4-2 1.4-2 2h1c1 0 1 0 2-.6 3.1 0 5.2.6 8.3.6l-2.1 1.4c-6.1 0-12.3.6-18.4.6h-1c1 1.4 4 2 10.2 2 0-.6 0 0 1-1.3 6.2-1.3 3 3.3 6.2 3.3 1 0 0-.6 0-.6 1 0 9.2.6 11.2 0-2 0-1-1.4-3-.7 0-.7 2 0 3-.7 1 .7 5.1 0 8.2 0v1.4c4.1 0 5.1 1.3 9.2 2 0 0 1 0 2-.7 0 1.3 5.2.7 8.3 0 0 .7 3 0 5.1 0v-.7h3c-2 0 0 0-1-.6h3.1l1 .6h4.2c2 0 1 0 1-1.3h-2c0-.7 2 0 2-1.3H207v.6h-2v-2s2 0 2-.6c-2 0-2-.7-4.1-.7h-6.2c7.2-1.3 17.4 0 24.6 0 0-.7 1-.7 2-1.3-1 0-1 0-2-.7 1-1.3 6.2-.7 7.2 0 0 .7-2 .7-2 1.3h3c0-.6 6.2 0 5.1-2 2 .7 7.2.7 11.3 1.4 1-.7 3-.7 4.1-2h5.1c2 0 3-.7 6.2-1.4 1 0 3-.6 5 0h1.1c.6.7-1 0-1 1.4 2 0 3 .6 4 .6 4.2-.6 8.3 0 10.3-.6 0 .6 3.1 0 5.2.6 0 1.4-4.1 2-6.2 2.7 3 0 3-.7 7.2 0 1 0-1-.7 1-1.3 0 0 0-.7 1-.7-1 0 0-1.3-1-2-3 0-5.1 0-6.1-.7 2 0 0-.6 1-.6s0 .6 2 .6h16.4c0 .7 1 .7 2 .7 1.1-.5 2.1-.7 3.1-.7s0 .7 1 .7c0-.7 2.1-.7 5.2-.7 0 1.4 5.1.7 7.2 1.4 0 .6 3 .6 1 2 2 .6 7.2.6 10.2 1.3 5.2-1.3 9.3 2 14.4.7 2 0 0 .6 2 1.3h6.2c0 .7 2 .7 3 1.3h6.2-.2c2 0 5.1.7 7.2.7v.7c3 0 6.5.6 10.2.6 0 .7 4.2 1.4 6.2.7 0 .7 0 .7 1 1.3-1 0-2 0-2 .7 5 0 9.2.7 13.3 0l1 .7c4 0 8.2-.7 13.3-.7H424c2 0 4-.7 6.1-.7 4.1 1.4 11.3 0 15.4-.6 0 0 0 .6 1 .6l1-.6c-2 0-3 0-5-.7h6c4.2 2 8.3-.7 14.4 0 1 0 0-.7 2-.7 2.1 0 5.2 0 7.2.7 0 .7 0 1.3 2 1.3 0 0-1 0-1-.6h2.1c-2 0 0-.7 1-1.4 1 0 0 .7 2 1.4h2.1c1-.7 4.1-.7 7.2-.7h8.2c2 0 4.1-.7 6.1-.7 4.1 0 10.3 0 15.4-.6 0 .6 0 .6 1 1.3 1 0 1-1.3 5.2-1.3 0 .6-1 0-1 1.3 2-.7 8.1 0 12.2-.7 4.1 0 6.2 0 9.3.7 1-.7 5-1.3 6.1-2.7-1-.6-6.1-1.3-9.2-1.3 1-.7 0-.7 0-2 3 0 9.2 0 11.3.7l1 .6 1.6-.1 1.2-.1z"/>
	</svg></svg>';
				break;
		}
		
		$overlay_output .='</div>';
		
	}
}

/* BOC - end */

$css_class = preg_replace( '/\s+/', ' ', apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( array_unique( $css_classes ) ) ), $this->settings['base'], $atts ) );
$wrapper_attributes[] = 'class="' . esc_attr( trim( $css_class ) ) . '"';

$output .= '<div ' . implode( ' ', $wrapper_attributes ) . '>'./* BOC - start */$overlay_output/* BOC - end */;
$output .= wpb_js_remove_wpautop( $content );
$output .= '</div>';
$output .= $after_output;

echo $output;