<?php 

get_header(); ?>

<div class="container layout_search">
	<div class="section">
	
		<div class="col span_3_of_4">
			
			<?php
			$items_per_page = 10;
			$post_loop_count = 1;
			$page = (get_query_var('paged')) ? get_query_var('paged') : 1;
			if($page > 1) $post_loop_count = ((int) ($page - 1) * $items_per_page) + 1;
			?>

			<div class="search_form_holder">
				<h3><?php esc_html_e('New Search', 'alea'); ?></h3>
				<p><?php esc_html_e("If you are not happy with the results below please do another search", 'alea');?></p>
				<form class="search" action="<?php echo home_url('/'); ?>/" method="get">
					<input name="s" id="s" type="text" placeholder="<?php echo esc_attr($s ? $s : esc_attr__('Search', 'alea').'...'); ?>" value=""/>
					<input type="submit" class="btn_theme_color" value="<?php esc_html_e('Search', 'alea'); ?>"/>
				</form>
			</div>

			<ol class="search_res">
			<?php $posts = query_posts($query_string . '&posts_per_page='.$items_per_page); ?>
			<?php if (have_posts()) : ?>
			<?php while (have_posts()) : the_post(); ?>
				<li><span class="s_post_count"><?php echo (int)$post_loop_count;?></span>
					<!-- Post Loop Begin -->
					<div class="s_post_item">
						<h3><a href="<?php the_permalink(); ?>" title="<?php printf(esc_attr__('Permalink to %s', 'alea'), the_title_attribute('echo=0')); ?>"><?php the_title(); ?></a> <span class="post_type_in_search"> (<?php echo get_post_type( $post ) ?>) </span></h3>

						<?php 
						echo boc_excerpt(28);
						?>

					</div>
					<!-- Post Loop End -->
				</li>
				<?php $post_loop_count++;?>
			<?php endwhile; ?>

			<?php boc_pagination($pages = '', $range = 2); ?>
			</ol>

			<?php else: ?>
			<p><?php esc_html_e('Sorry, no posts matched your criteria.','alea'); ?></p>
			<?php endif; // Loop End  ?>

			<div class="h40 clear"></div>
			
		</div>
		
		<!-- Search Sidebar -->
		<div id="sidebar" class="col span_1_of_4 sidebar">
		<?php if ( ! dynamic_sidebar('Search Page Sidebar') ) : ?>
		<?php endif; ?>
		</div>
		
		
	</div>	
</div>

<?php get_footer(); ?>	